/***************************************************************************
 *          solve_stat    .cpp                                             *
 *          solve images=XB                                                *
 *          5/19/08                                                        *
 ***************************************************************************/

#include <fstream>
#include <blitz/array.h>
#include <random/uniform.h>
#include <time.h>

#include <omp.h>

using namespace std;
using namespace ranlib;
BZ_USING_NAMESPACE(blitz)

int cholesky_solve(Array<float,5> images, Array<float, 2> X, Array<float,5> B,Array<int,1> ranIndex, int perm);
int cholesky_solve_static(Array<float,2> Y, Array<float, 2> X, Array<float,5> B,Array<int,1> ranIndex, int perm);
int cholesky_solve_spvar(Array<float,5> images, Array<float,6> ind_images,int num_spvar_indep_var,Array<float, 2> X,Array<float,6> XTXextra, Array<float,5> B,Array<int,1> ranIndex, int perm);
int cholesky_solve_static_spvar(Array<float,2> Y, Array<float,6> ind_images,int num_spvar_indep_var,Array<float, 2> X,Array<float,6> XTXextra, Array<float,5> B,Array<int,1> ranIndex, int perm);
int cholesky_solve_mult_static_spvar(Array<float,2> Y, Array<float,6> ind_images,int num_spvar_indep_var,Array<float, 2> X, Array<float,6> XTXextra,Array<float,5> B,Array<int,1> ranIndex, int perm);
int SSResids(Array<float,5> images, Array<float,2> X, Array<float,5> Bimage, Array<float,5> SSHimage,Array<int,1> ranIndex,int perm);
int SSResids_static(Array<float,2> Y, Array<float,2> X, Array<float,5> Bimage, Array<float,5> SSHimage,Array<int,1> ranIndex,int perm);
int calc_F_image(Array<float,5> SSHimage,Array<float,5> SSEimage,Array<float,3> Stat_image, int p,int v, int q, float *df1, float *df2);
int calc_param_image(Array<float,5> Bimage,Array<float,5> SSEimage,Array<float,5> Stat_param_image,Array<float,2> X,Array<float,2> invXTX,float *df);
int calc_R2_image(Array<float,5> SSEimage,Array<float,5> SSHimage,Array<float,4> R2image);
int fchdecomp(Array<float,2> A, Array<float,2> L);
int fforwardsub(Array<float,2> L, Array<float,5> XTY, Array<float,5> tmpb);
int fbacksub(Array<float, 2> L, Array<float,5> tmpb, Array<float,5> Beta);
int fchdecomp_image(Array<float,5> A, Array<float,5> L);
int determSPD(Array<float,5> image_matrix, Array<float,3> image_det);
int fforwardsub_vec(Array<float,2> L, Array<float,1> vec, Array<float,1> beta);
int inv_lower(Array<float,2> L, Array<float,2> invL);
int invSPD(Array<float,2> X, Array<float,2> invX);
int calc_contrast_images(Array<float,2> C1,Array<float,2> invXTX,Array<float,5> Bimage,Array<float,5> SSEimage,Array<float,5> Contrast_image,Array<float,5> F_contrast_image,float *df);
void indexx(int n, Array<float,1> arrin, Array<int,1> indx);
void mysort(Array<float,1> data, int N);
int update_fchdecomp(Array<float,2> Update, Array<float,2> L);
int fbacksub_vox(Array<float,2> L, Array<float,1> b_vox, Array<float,1> beta_vox);
int SSResids_spvar(Array<float,5> images, Array<float,6> ind_images,int num_spvar_indep_var,Array<float,2> X, Array<float,5> Bimage, Array<float,5> SSHimage,Array<int,1> ranIndex,int perm);
int SSResids_spvar_static(Array<float,2> Y, Array<float,6> ind_images,int num_spvar_indep_var,Array<float,2> X, Array<float,5> Bimage, Array<float,5> SSHimage,Array<int,1> ranIndex,int perm);
int calc_param_image_spvar(Array<float,5> Bimage,Array<float,5> SSEimage,Array<float,5> Stat_param_image,Array<float,6> invXTX_spvar,float *df);
int calc_param_image_spvar_multi(Array<float,5> Bimage,Array<float,5> SSEimage,Array<float,5> Stat_param_image,Array<float,6> invXTX_spvar,float *df);
int calc_contrast_images_spvar(Array<float,2> C1,Array<float,6> invXTX_spvar,Array<float,5> Bimage,Array<float,5> SSEimage,Array<float,5> Contrast_image,Array<float,5> F_contrast_image,float *df);
int calc_contrast_images_spvar_multi(Array<float,2> C1, Array<float,6> invXTX_spvar, Array<float,5> Bimage,Array<float,5> SSEimage,Array<float,5> Contrast_image,Array<float,5> F_contrast_image,float *df);
int invSPD_spvar(Array<float,2> X,Array<float,6> XTXextra,Array<float,6>invXTX_spvar);
int SSH2make(Array<float,2> X,Array<float,2> invXTX,Array<float,5> Bimage,Array<float,6> SSH2image);
int calc_F_image_multi(Array<float,5> SSHimage,Array<float,5> SSEimage,Array<float,3> detSSE,Array<float,6> SSH2image,Array<float,3> Stat_image, Array<float,4> FStat_Manova,int p,int v, int q,float *df1, float *df2,float *df3, float *df4);
int SSH2make_multi(Array<float,2> C1,Array<float,2> invXTX,Array<float,5> Bimage,Array<float,6> SSH2image);
int SSH2make_spvar(Array<float,6> invXTX_spvar,Array<float,5> Bimage,Array<float,6> SSH2image);
int calc_contrast_images_multi(Array<float,5> SSEimage,Array<float,5> SSHimage,Array<float,6> SSH2image,Array<float,3> detSSE,Array<float,4> F_contrast_image_multi,int p,float *df3,float *df4);

int solve_stat(ofstream *toFile,Array<float,5> images,Array<float,2> X,Array<float,2> X2,Array<float,2> C1, Array<float,5> Bimage,Array<float,5> B2image,Array<float,3> Stat_image,float *df1, float *df2, Array<float,5> Stat_param_image, float *tdf, Array<float,5> Contrast_image,Array<float,5> F_contrast_image,float *cdf1, float *cdf2, Array<float,4> Stat_R2_image,Uniform<float> unif, int perm) {
  int fin_OK;
  int a;
  firstIndex i;
  Array<float,1> ranVec(images.extent(fifthDim));
  Array<int,1> ranIndex(images.extent(fifthDim));
  if(perm!=0) {
    for(a=0; a<ranVec.rows(); a++) {
      ranVec(a)=unif.random();
    }
    indexx(ranVec.rows(),ranVec,ranIndex);
  }
  else ranIndex=i;

  clock_t start, end;
  // now solve full problem using Cholesky decomposition
  start=clock();

  #pragma omp parallel
  {
  #pragma omp sections nowait
  {
  #pragma omp section
      {
  if( (fin_OK=cholesky_solve(images,X,Bimage,ranIndex, perm))!=0) {
    *(toFile) << "ERROR: could not solve full least squares problem" << endl;
    cout << "ERROR: could not solve full least squares problem, exiting" << endl;
    exit(1);
  }
      }
  #pragma omp section
      {
  // now solve reduced problem using Cholesky decomposition
  if( (fin_OK=cholesky_solve(images,X2,B2image,ranIndex, perm))!=0) {
    *(toFile) << "ERROR: could not solve reduced least squares problem" << endl;
    cout << "ERROR: could not solve reduced least squares problem, exiting" << endl;
    exit(1);
  }
      }
  }
  }
  end=clock();

  // now calculate SSE and SSH
  Array<float,5> SSHimage(images.extent(firstDim), images.extent(secondDim),images.extent(thirdDim),images.extent(fourthDim),images.extent(fourthDim));
  Array<float,5> SSEimage(images.extent(firstDim), images.extent(secondDim),images.extent(thirdDim),images.extent(fourthDim),images.extent(fourthDim));
  start=clock();
  #pragma omp parallel
  {
      #pragma omp sections nowait
      {
          #pragma omp section
          {
  if( (fin_OK=SSResids(images,X,Bimage,SSEimage,ranIndex,perm))!=0) {
    *(toFile) << "ERROR: could not compute SSH" << endl;
    cout << "ERROR: could not computer SSH, exiting" << endl;
    exit(1);
  }
      }
      #pragma omp section
      {
  if( (fin_OK=SSResids(images,X2,B2image,SSHimage,ranIndex,perm))!=0) {
    *(toFile) << "ERROR: could not compute SSH" << endl;
    cout << "ERROR: could not computer SSH, exiting" << endl;
    exit(1);
  }
      }
      }
  }
  end=clock();
//  cout << "SSResids time " << end-start << endl;
  start=clock();
  Array<float,2> invXTX(X.extent(secondDim),X.extent(secondDim));
  *tdf=images.extent(fifthDim)-(X.extent(secondDim)-X2.extent(secondDim))-1;

  #pragma omp parallel
  {
      #pragma omp sections nowait
      {
          #pragma omp section
          {
  // now calculate F statistics, R2 image, T2 statistics for each variable
  if( (fin_OK=calc_F_image(SSHimage,SSEimage,Stat_image, images.extent(fourthDim),images.extent(fifthDim)-X.extent(secondDim),X.extent(secondDim)-X2.extent(secondDim),df1,df2))!=0) {
    *(toFile) << "ERROR: could not compute model F image" << endl;
    cout << "ERROR: could not computer model F imgae, exiting" << endl;
    exit(1);
  }
          }
          #pragma omp section
          {
  //  *(toFile) << "F_image " << min(Stat_image(Range::all(),Range::all(),Range::all())) << "\t" << max(Stat_image(Range::all(),Range::all(),Range::all())) << endl;
  if( (fin_OK=calc_param_image(Bimage,SSEimage,Stat_param_image,X,invXTX,tdf ))!=0) {
    *(toFile) << "ERROR: could not compute t-statistic images for each independent variable" << endl;
    cout << " ERROR: could not computer t-statistic images for each independent variable, exiting" << endl;
    exit(1);
  }
          }
      }
  }
  end=clock();
//  cout << "F image and stat_param_image time " << end-start << endl;
  //  for(a=0; a<Stat_param_image.extent(fifthDim); a++) *(toFile) << "Stat_param_image " << a << "\t" << min(Stat_param_image(Range::all(), Range::all(), Range::all(), Range::all(), a)) << "\t" << max(Stat_param_image(Range::all(), Range::all(), Range::all(), Range::all(),a)) << endl;
start=clock();
#pragma omp parallel
  {
  #pragma omp sections nowait
      {
      #pragma omp section
          {
  if(C1.extent(firstDim)!=0) {
    *cdf1=C1.extent(firstDim);
    *cdf2=images.extent(fifthDim)-X.extent(secondDim);
    if( (fin_OK=calc_contrast_images(C1,invXTX,Bimage,SSEimage,Contrast_image,F_contrast_image,cdf2)!=0)) {
      *(toFile) << "ERROR: could not compute contrast images" << endl;
      cout << "ERROR: could not compute contrast images, exiting" << end;
      exit(1);
    }
  }
          }
          #pragma omp section
          {
  if( (fin_OK=calc_R2_image(SSEimage,SSHimage,Stat_R2_image))!=0) {
    *(toFile) << "ERROR: could not calculate R2 images" << endl;
    cout << "ERROR: could not calculate R2 images, exiting" << endl;
    exit(1);
  }
          }
      }
  }
          end=clock();
//          cout << " contrast and R2 time " << end-start << endl;
  return(0);
}

int solve_stat_spvar(ofstream *toFile,Array<float,5> images,Array<float,6> ind_images,int num_spvar_indep_var, Array<float,2> X,Array<float,2> X2,Array<float,2> C1, Array<float,5> Bimage,Array<float,5> B2image,Array<float,3> Stat_image,float *df1, float *df2, Array<float,5> Stat_param_image, float *tdf, Array<float,5> Contrast_image,Array<float,5> F_contrast_image,float *cdf1, float *cdf2, Array<float,4> Stat_R2_image,Uniform<float> unif, int perm) {
  int fin_OK;
  int a;
  firstIndex i;
  secondIndex j;
  thirdIndex k;
  Array<float,1> ranVec(images.extent(fifthDim));
  Array<int,1> ranIndex(images.extent(fifthDim));

  if(perm!=0) {
    for(a=0; a<ranVec.rows(); a++) {
      ranVec(a)=unif.random();
    }
    indexx(ranVec.rows(),ranVec,ranIndex);
  }
  else ranIndex=i;

  //create XTXextra (extra rows for cholesky decomposition)
  Array<float,6> XTXextra(ind_images.extent(firstDim),ind_images.extent(secondDim),ind_images.extent(thirdDim),ind_images.extent(fourthDim),X.extent(secondDim),num_spvar_indep_var);

  // now solve full problem using Cholesky decomposition
  if( (fin_OK=cholesky_solve_spvar(images,ind_images,num_spvar_indep_var,X,XTXextra,Bimage,ranIndex, perm))!=0) {
    *(toFile) << "ERROR: could not solve full least squares problem" << endl;
    cout << "ERROR: could not solve full least squares problem, exiting" << endl;
    exit(1);
  }

  // now solve reduced problem using Cholesky decomposition
  if( (fin_OK=cholesky_solve(images,X2,B2image,ranIndex, perm))!=0) {
    *(toFile) << "ERROR: could not solve reduced least squares problem" << endl;
    cout << "ERROR: could not solve reduced least squares problem, exiting" << endl;
    exit(1);
  }
  // if desired, correct for imageMask
  //  for(a=0; a<num_effects+num_confounds; a++) Bimage(Range::all(), Range::all(), Range::all(), Range::all(),a)*=imageMask;
  //  for(a=0; a<num_confounds; a++) B2image(Range::all(), Range::all(), Range::all(), Range::all(),a)*=imageMask;

  // write min and max values for each beta to file
  //  for(a=0; a<Bimage.extent(fifthDim); a++) *(toFile) << "Bimage " << a << "\t" << min(Bimage(Range::all(), Range::all(), Range::all(), Range::all(), a)) << "\t" << max(Bimage(Range::all(), Range::all(), Range::all(), Range::all(),a)) << endl;
  //  for(a=0; a<B2image.extent(fifthDim); a++) *(toFile) << "B2image " << a << "\t" << min(B2image(Range::all(), Range::all(), Range::all(), Range::all(), a)) << "\t" << max(B2image(Range::all(), Range::all(), Range::all(), Range::all(),a)) <<endl;
  // now calculate SSE and SSH
  Array<float,5> SSHimage(images.extent(firstDim), images.extent(secondDim),images.extent(thirdDim),images.extent(fourthDim),images.extent(fourthDim));
  Array<float,5> SSEimage(images.extent(firstDim), images.extent(secondDim),images.extent(thirdDim),images.extent(fourthDim),images.extent(fourthDim));

  if( (fin_OK=SSResids_spvar(images,ind_images,num_spvar_indep_var,X,Bimage,SSEimage,ranIndex,perm))!=0) {
    *(toFile) << "ERROR: could not compute SSH" << endl;
    cout << "ERROR: could not compute SSH, exiting" << endl;
    exit(1);
  }
  if( (fin_OK=SSResids(images,X2,B2image,SSHimage,ranIndex,perm))!=0) {
    *(toFile) << "ERROR: could not compute SSH" << endl;
    cout << "ERROR: could not computer SSH, exiting" << endl;
    exit(1);
  }
  
  // now calculate F statistics, R2 image, T2 statistics for each variable
  if( (fin_OK=calc_F_image(SSHimage,SSEimage,Stat_image, images.extent(fourthDim),images.extent(fifthDim)-X.extent(secondDim),X.extent(secondDim)-X2.extent(secondDim),df1,df2))!=0) {
    *(toFile) << "ERROR: could not compute model F image" << endl;
    cout << "ERROR: could not compute model F image, exiting" << endl;
    exit(1);
  }
  //  *(toFile) << "F_image " << min(Stat_image(Range::all(),Range::all(),Range::all())) << "\t" << max(Stat_image(Range::all(),Range::all(),Range::all())) << endl;
  Array<float,6> invXTX_spvar(images.extent(firstDim),images.extent(secondDim),images.extent(thirdDim),images.extent(fourthDim),X.extent(secondDim),X.extent(secondDim));
  Array<float,2> XTX(X.extent(secondDim),X.extent(secondDim));
 XTX=sum( X(k,i)*X(k,j),k);

  // fill invXTX_spvar with inverse of matrix at all voxels
  if( (fin_OK=invSPD_spvar(XTX,XTXextra,invXTX_spvar) ) !=0 ) {
    cout << "ERROR: could not invert SPD matrix at every voxel, exiting" << endl;
    exit(1);
  }

  *tdf=images.extent(fifthDim)-(X.extent(secondDim)-X2.extent(secondDim))-1;
  if( (fin_OK=calc_param_image_spvar(Bimage,SSEimage,Stat_param_image,invXTX_spvar,tdf ))!=0) {
    *(toFile) << "ERROR: could not compute t-statistic images for each independent variable" << endl;
    cout << "ERROR: could not computer t-statistic images for each independent variable, exiting" << endl;
    exit(1);
  }
  //  for(a=0; a<Stat_param_image.extent(fifthDim); a++) *(toFile) << "Stat_param_image " << a << "\t" << min(Stat_param_image(Range::all(), Range::all(), Range::all(), Range::all(), a)) << "\t" << max(Stat_param_image(Range::all(), Range::all(), Range::all(), Range::all(),a)) << endl;
  if(C1.extent(firstDim)!=0) {
    *cdf1=C1.extent(firstDim);
    *cdf2=images.extent(fifthDim)-X.extent(secondDim);
    if( (fin_OK=calc_contrast_images_spvar(C1,invXTX_spvar,Bimage,SSEimage,Contrast_image,F_contrast_image,cdf2)!=0)) {
      *(toFile) << "ERROR: could not compute contrast images" << endl;
      cout << "ERROR: could not computer contrast images, exiting" << endl;
      exit(1);
    }
  }
  if( (fin_OK=calc_R2_image(SSEimage,SSHimage,Stat_R2_image))!=0) {
    *(toFile) << "ERROR: could not calculate R2 images" << endl;
    cout << "ERROR: could not calculate R2 images, exiting" << endl;
    exit(1);
  }
  return(0);
}

int solve_stat_multi(ofstream *toFile,Array<float,5> images,Array<float,2> X,Array<float,2> X2,Array<float,2> C1, Array<float,5> Bimage,Array<float,5> B2image,Array<float,3> Stat_image,Array<float,4> FStat_Manova,float *df1, float *df2, float *df3, float *df4, Array<float,5> Stat_param_image, float *tdf, Array<float,5> Contrast_image,Array<float,5> F_contrast_image,Array<float,4> F_contrast_image_multi,float *cdf1, float *cdf2, Array<float,4> Stat_R2_image,Uniform<float> unif, int perm) {
  int fin_OK;
  int a;
  firstIndex i;
  Array<float,1> ranVec(images.extent(fifthDim));
  Array<int,1> ranIndex(images.extent(fifthDim));
  if(perm!=0) {
    for(a=0; a<ranVec.rows(); a++) {
      ranVec(a)=unif.random();
    }
    indexx(ranVec.rows(),ranVec,ranIndex);
  }
  else ranIndex=i;

  //  cout << "before cholesky_solve" << endl;
  // now solve full problem using Cholesky decomposition
  if( (fin_OK=cholesky_solve(images,X,Bimage,ranIndex, perm))!=0) {
    *(toFile) << "ERROR: could not solve full least squares problem" << endl;
    cout << "ERROR: could not solve full least squares problem, exiting" << endl;
    exit(1);
  }
  //  cout << "after cholesky_solve for full X" << endl;
  //  cout << Bimage(0,0,0,Range::all(),Range::all()) << endl;

  // now solve reduced problem using Cholesky decomposition
  if( (fin_OK=cholesky_solve(images,X2,B2image,ranIndex, perm))!=0) {
    *(toFile) << "ERROR: could not solve reduced least squares problem" << endl;
    cout << "ERROR: could not solve reduced least squares problem, exiting" << endl;
    exit(1);
  }
  //  cout << "after cholesky_solve for reduced X" << endl;
  //  cout << B2image(0,0,0,Range::all(),Range::all()) << endl;

  // if desired, correct for imageMask
  //  for(a=0; a<num_effects+num_confounds; a++) Bimage(Range::all(), Range::all(), Range::all(), Range::all(),a)*=imageMask;
  //  for(a=0; a<num_confounds; a++) B2image(Range::all(), Range::all(), Range::all(), Range::all(),a)*=imageMask;

  // write min and max values for each beta to file
  //  for(a=0; a<Bimage.extent(fifthDim); a++) *(toFile) << "Bimage " << a << "\t" << min(Bimage(Range::all(), Range::all(), Range::all(), Range::all(), a)) << "\t" << max(Bimage(Range::all(), Range::all(), Range::all(), Range::all(),a)) << endl;
  //  for(a=0; a<B2image.extent(fifthDim); a++) *(toFile) << "B2image " << a << "\t" << min(B2image(Range::all(), Range::all(), Range::all(), Range::all(), a)) << "\t" << max(B2image(Range::all(), Range::all(), Range::all(), Range::all(),a)) <<endl;
  // now calculate SSE and SSH
  Array<float,5> SSHimage(images.extent(firstDim), images.extent(secondDim),images.extent(thirdDim),images.extent(fourthDim),images.extent(fourthDim));
  Array<float,5> SSEimage(images.extent(firstDim), images.extent(secondDim),images.extent(thirdDim),images.extent(fourthDim),images.extent(fourthDim));
  Array<float,6> SSH2image(images.extent(firstDim), images.extent(secondDim), images.extent(thirdDim), X.extent(secondDim)-1,images.extent(fourthDim),images.extent(fourthDim));

  if( (fin_OK=SSResids(images,X,Bimage,SSEimage,ranIndex,perm))!=0) {
    *(toFile) << "ERROR: could not compute SSH" << endl;
    cout << "ERROR: could not computer SSH, exiting" << endl;
    exit(1);
  }
  //  cout << "after SSResids for full X" << endl;
  if( (fin_OK=SSResids(images,X2,B2image,SSHimage,ranIndex,perm))!=0) {
    *(toFile) << "ERROR: could not compute SSH" << endl;
    cout << "ERROR: could not computer SSH, exiting" << endl;
    exit(1);
  }
  if( (fin_OK=calc_R2_image(SSEimage,SSHimage,Stat_R2_image))!=0) {
    *(toFile) << "ERROR: could not calculate R2 images" << endl;
    cout << "ERROR: could not calculate R2 images, exiting" << endl;
    exit(1);
  }
  // now make SSH2image, which is (LB')(L(XTX)-1L')-1(LB), sort of
  Array<float,2> invXTX(X.extent(secondDim),X.extent(secondDim));
  if( (fin_OK=SSH2make(X,invXTX,Bimage,SSH2image)) !=0) {
    *(toFile) << "ERROR: could not compute SSH2" << endl;
    cout << "ERROR: could not computer SSH2, exiting" << endl;
    exit(1);
  }

  // now calculate F statistics, R2 image, T2 statistics for each variable
  //  cout << "before calc_F_image_multi " << endl;
  Array<float,3> detSSE(SSEimage.extent(firstDim),SSEimage.extent(secondDim),SSEimage.extent(thirdDim));
  if( (fin_OK=calc_F_image_multi(SSHimage,SSEimage,detSSE,SSH2image,Stat_image, FStat_Manova,images.extent(fourthDim),images.extent(fifthDim)-X.extent(secondDim),X.extent(secondDim)-X2.extent(secondDim),df1,df2,df3,df4))!=0) {
    *(toFile) << "ERROR: could not compute model F image" << endl;
    cout << "ERROR: could not computer model F image, exiting" << endl;
    exit(1);
  }
  //  *(toFile) << "F_image " << min(Stat_image(Range::all(),Range::all(),Range::all())) << "\t" << max(Stat_image(Range::all(),Range::all(),Range::all())) << endl;

  *tdf=images.extent(fifthDim)-(X.extent(secondDim)-X2.extent(secondDim))-1;
  if( (fin_OK=calc_param_image(Bimage,SSEimage,Stat_param_image,X,invXTX,tdf ))!=0) {
    *(toFile) << "ERROR: could not compute t-statistic images for each independent variable" << endl;
    cout << "ERROR: could not compute t-statistic images for each independent variable, exiting" << endl;
    exit(1);
  }
  //for(a=0; a<Stat_param_image.extent(fifthDim); a++) *(toFile) << "Stat_param_image " << a << "\t" << min(Stat_param_image(Range::all(), Range::all(), Range::all(), Range::all(), a)) << "\t" << max(Stat_param_image(Range::all(), Range::all(), Range::all(), Range::all(),a)) << endl;
  //cout << Stat_param_image(0,0,0,Range::all(),Range::all()) << endl;
  //cout << Stat_param_image(11,13,16,Range::all(),Range::all()) << endl;
  if(C1.extent(firstDim)!=0) {
    *cdf1=C1.extent(firstDim);
    *cdf2=images.extent(fifthDim)-X.extent(secondDim);
    // now make SSH2image, which is (CB')(C(XTX)-1C')-1(CB), sort of
    // resize SSH2image for number of contrasts (not number of independent variables
    SSH2image.resize(Bimage.extent(firstDim),Bimage.extent(secondDim),Bimage.extent(thirdDim),C1.extent(firstDim),images.extent(fourthDim),images.extent(fourthDim));
    if( (fin_OK=SSH2make_multi(C1,invXTX,Bimage,SSH2image)) !=0) {
      *(toFile) << "ERROR: could not compute SSH2" << endl;
      cout << "ERROR: could not computer SSH2, exiting" << endl;
      exit(1);
    }    
    if( (fin_OK=calc_contrast_images(C1,invXTX,Bimage,SSEimage,Contrast_image,F_contrast_image,cdf2)!=0)) {
       *(toFile) << "ERROR: could not compute contrast images" << endl;
       cout << "ERROR: could not computer contrast images, exiting" << endl;
       exit(1);
    }
    if( (fin_OK=calc_contrast_images_multi(SSEimage,SSHimage,SSH2image,detSSE,F_contrast_image_multi,images.extent(fourthDim),df3,df4))!=0) {
      (*toFile) << "ERROR: could not compute contrasts on overall  model" << endl;
      cout << "ERROR: could ont compute contrast on overall model, exiting" << endl;
      exit(1);
    }
    }
  return(0);
}


int cholesky_solve(Array<float,5> images, Array<float, 2> X, Array<float,5> B,Array<int,1> ranIndex, int perm) {
  int fin_OK;
  int c,d;
  Array<float,2> XTX(X.extent(secondDim),X.extent(secondDim));
  Array<float,2> L(X.extent(secondDim), X.extent(secondDim));
  L=0.;

  firstIndex i;
  secondIndex j;
  thirdIndex k;

  //  XTX=sum( (X.transpose(secondDim,firstDim))(i,k)*X(k,j),k);
  XTX=sum( X(k,i)*X(k,j),k);
 
  if((fin_OK=fchdecomp(XTX,L))!=0) {
    cout << "error in cholesky decomposition, exiting" << endl;
    exit(1);
  }

  // now to forward substitution
  // create XTY
  Array<float,5> XTY(images.extent(firstDim), images.extent(secondDim), images.extent(thirdDim), images.extent(fourthDim), X.extent(secondDim));
  Array<float,5> tmpb(images.extent(firstDim), images.extent(secondDim), images.extent(thirdDim), images.extent(fourthDim), X.extent(secondDim));
  clock_t start, end;
  XTY=0.;
  start=clock();
  if(perm==0) {
      #pragma omp parallel for private(c,d)
    for(c=0; c<X.extent(secondDim); c++) {
      for(d=0; d<images.extent(fifthDim); d++) {
	XTY(Range::all(), Range::all(), Range::all(), Range::all(),c)+=X(d,c)*images(Range::all(), Range::all(), Range::all(), Range::all(),d);
      }
    }
  }
  else {
      #pragma omp parallel for private(c,d)
    for(c=0; c<X.extent(secondDim); c++) {
        for(d=0; d<images.extent(fifthDim); d++) {
            XTY(Range::all(), Range::all(), Range::all(), Range::all(),c)+=X(ranIndex(d),c)*images(Range::all(), Range::all(), Range::all(), Range::all(),d);
        }
    }
  }
  end=clock();

  if( (fin_OK=fforwardsub(L,XTY, tmpb))!=0) {
    cout << "error in forward substitution, exiting" << endl;
    exit(1);
  }

  
  // now for back substitution and solution
  if( (fin_OK=fbacksub(L.transpose(secondDim,firstDim),tmpb,B))!=0) {
    cout << "error in back substituton, exitingf" << endl;
    exit(1);
    }

  return(0);
}

int cholesky_solve_static(Array<float,2> Y, Array<float, 2> X, Array<float,5> B,Array<int,1> ranIndex, int perm) {
  int fin_OK;
  int c,d;
  Array<float,2> XTX(X.extent(secondDim),X.extent(secondDim));
  Array<float,2> L(X.extent(secondDim), X.extent(secondDim));
  L=0.;

  firstIndex i;
  secondIndex j;
  thirdIndex k;

  //  XTX=sum( (X.transpose(secondDim,firstDim))(i,k)*X(k,j),k);
  XTX=sum( X(k,i)*X(k,j),k);
 
  if((fin_OK=fchdecomp(XTX,L))!=0) {
    cout << "error in cholesky decomposition, exiting" << endl;
    exit(1);
  }

  // now to forward substitution
  // create XTY
  Array<float,5> XTY(B.extent(firstDim), B.extent(secondDim), B.extent(thirdDim), B.extent(fourthDim), X.extent(secondDim));
  Array<float,5> tmpb(B.extent(firstDim), B.extent(secondDim), B.extent(thirdDim), B.extent(fourthDim), X.extent(secondDim));
  //  clock_t start, end;
  XTY=0.;
  //  start=clock();
  if(perm==0) {
    for(d=0; d<Y.extent(secondDim); d++) {
      for(c=0; c<X.extent(secondDim); c++) {
	XTY(Range::all(), Range::all(), Range::all(), Range::all(),c)+=X(d,c)*Y(0,d);
      }
    }
  }
  else {
    for(d=0; d<Y.extent(secondDim); d++) {
      for(c=0; c<X.extent(secondDim); c++) {
	XTY(Range::all(), Range::all(), Range::all(), Range::all(),c)+=X(ranIndex(d),c)*Y(0,d);
      }
    }
  }
  //  end=clock();
  //cout << "computer time2= " << start << "\t" << end << endl;

  
  if( (fin_OK=fforwardsub(L,XTY, tmpb))!=0) {
    cout << "error in forward substitution, exiting" << endl;
    exit(1);
  }
  
  // now for back substitution and solution
  if( (fin_OK=fbacksub(L.transpose(secondDim,firstDim),tmpb,B))!=0) {
    cout << "error in back substituton, exiting" << endl;
    exit(1);
    }
  return(0);
}

int cholesky_solve_mult_static(Array<float,2> Y, Array<float, 2> X, Array<float,5> B,Array<int,1> ranIndex, int perm) {
  int fin_OK;
  int b,c,d;
  Array<float,2> XTX(X.extent(secondDim),X.extent(secondDim));
  Array<float,2> L(X.extent(secondDim), X.extent(secondDim));
  L=0.;

  firstIndex i;
  secondIndex j;
  thirdIndex k;

  //  XTX=sum( (X.transpose(secondDim,firstDim))(i,k)*X(k,j),k);
  XTX=sum( X(k,i)*X(k,j),k);
 
  if((fin_OK=fchdecomp(XTX,L))!=0) {
    cout << "error in cholesky decomposition, exiting" << endl;
    exit(1);
  }

  // now to forward substitution
  // create XTY
  Array<float,5> XTY(B.extent(firstDim), B.extent(secondDim), B.extent(thirdDim), B.extent(fourthDim), Y.extent(firstDim),X.extent(secondDim));
  Array<float,5> tmpb(B.extent(firstDim), B.extent(secondDim), B.extent(thirdDim), B.extent(fourthDim), Y.extent(firstDim),X.extent(secondDim));
  //  clock_t start, end;
  XTY=0.;
  //  start=clock();
  if(perm==0) {
    for(b=0; b<Y.extent(firstDim); b++) {
      for(d=0; d<Y.extent(secondDim); d++) {
	for(c=0; c<X.extent(secondDim); c++) {
	  XTY(Range::all(), Range::all(), Range::all(), b,c)+=X(d,c)*Y(b,d);
	}
      }
    }
  }
  else {
    for(b=0; b<Y.extent(firstDim); b++) {
      for(d=0; d<Y.extent(secondDim); d++) {
	for(c=0; c<X.extent(secondDim); c++) {
	  XTY(Range::all(), Range::all(), Range::all(), b,c)+=X(ranIndex(d),c)*Y(b,d);
	}
      }
    }
  }
  //  end=clock();
  //cout << "computer time2= " << start << "\t" << end << endl;

  
  if( (fin_OK=fforwardsub(L,XTY, tmpb))!=0) {
    cout << "error in forward substitution, exiting" << endl;
    exit(1);
  }
  
  // now for back substitution and solution
  if( (fin_OK=fbacksub(L.transpose(secondDim,firstDim),tmpb,B))!=0) {
    cout << "error in back substituton, exiting" << endl;
    exit(1);
    }
  return(0);
}


int cholesky_solve_spvar(Array<float,5> images, Array<float,6> ind_images,int num_spvar_indep_var,Array<float, 2> X, Array<float,6> XTXextra,Array<float,5> B,Array<int,1> ranIndex, int perm) {
  int fin_OK;
  int a,b,c,d;
  Array<float,2> XTX(X.extent(secondDim),X.extent(secondDim));

  firstIndex i;
  secondIndex j;
  thirdIndex k;

  // first add a column to X matrix to initialize; use value from middle of image (try to avoid all zero background)
  for(a=0; a<num_spvar_indep_var; a++) {
    for(b=0; b<X.extent(firstDim); b++) {
      X(b,X.extent(secondDim)-a-1)=ind_images((int)ind_images.extent(firstDim)/2,(int)ind_images.extent(secondDim)/2,(int)ind_images.extent(thirdDim)/2,0,a,b);
    }
  }
  //cout << X << endl;
  

  // create XTY
  Array<float,5> XTY(images.extent(firstDim), images.extent(secondDim), images.extent(thirdDim), images.extent(fourthDim), X.extent(secondDim));
  Array<float,5> tmpb(images.extent(firstDim), images.extent(secondDim), images.extent(thirdDim), images.extent(fourthDim), X.extent(secondDim));
//  clock_t start, end;
//  start=clock();
  XTY=0.;
  XTXextra=0.;

   //  start=clock();
  if(perm==0) {
      #pragma omp parallel for private(d,a,c)
      for(a=0; a<num_spvar_indep_var; a++) {
	for(c=0; c<X.extent(secondDim)-num_spvar_indep_var; c++) {
               for(d=0; d<images.extent(fifthDim); d++) {
	  XTXextra(Range::all(),Range::all(),Range::all(),Range::all(),c,a)+=X(d,c)*ind_images(Range::all(),Range::all(),Range::all(),Range::all(),a,d);
	}
      }
 
	for(c=0; c<num_spvar_indep_var; c++) {
               for(d=0; d<images.extent(fifthDim); d++) {
	  XTXextra(Range::all(),Range::all(),Range::all(),Range::all(),c+X.extent(secondDim)-num_spvar_indep_var,a)+=ind_images(Range::all(),Range::all(),Range::all(),Range::all(),a,d)*ind_images(Range::all(),Range::all(),Range::all(),Range::all(),c,d);
	}
      }
      }
      #pragma omp parallel for private(c,d)
      for(c=0; c<X.extent(secondDim)-num_spvar_indep_var; c++) {
             for(d=0; d<images.extent(fifthDim); d++) {
	XTY(Range::all(), Range::all(), Range::all(), Range::all(),c)+=X(d,c)*images(Range::all(), Range::all(), Range::all(), Range::all(),d);
      }
      }
      #pragma omp parallel for private(c,d)
      for(c=X.extent(secondDim)-num_spvar_indep_var; c<X.extent(secondDim); c++) {
             for(d=0; d<images.extent(fifthDim); d++) {
	XTY(Range::all(), Range::all(), Range::all(), Range::all(),c)+=ind_images(Range::all(),Range::all(),Range::all(),Range::all(),c-(X.extent(secondDim)-num_spvar_indep_var),d)*images(Range::all(),Range::all(),Range::all(),Range::all(),d);
      }
    }
  }
  else {
      #pragma omp parallel for private(a,c,d)
      for(a=0; a<num_spvar_indep_var; a++) {
	for(c=0; c<X.extent(secondDim)-num_spvar_indep_var; c++) {
                for(d=0; d<images.extent(fifthDim); d++) {
	  XTXextra(Range::all(),Range::all(),Range::all(),Range::all(),c,a)+=X(d,c)*ind_images(Range::all(),Range::all(),Range::all(),Range::all(),a,d);
	}
      }
	for(c=0; c<num_spvar_indep_var; c++) {
                for(d=0; d<images.extent(fifthDim); d++) {
	  XTXextra(Range::all(),Range::all(),Range::all(),Range::all(),c+X.extent(secondDim)-num_spvar_indep_var,a)+=ind_images(Range::all(),Range::all(),Range::all(),Range::all(),a,d)*ind_images(Range::all(),Range::all(),Range::all(),Range::all(),c,d);
	}
      }
      }
      #pragma omp parallel for private(c,d)
      for(c=0; c<X.extent(secondDim)-num_spvar_indep_var; c++) {
              for(d=0; d<images.extent(fifthDim); d++) {
	XTY(Range::all(), Range::all(), Range::all(), Range::all(),c)+=X(ranIndex(d),c)*images(Range::all(), Range::all(), Range::all(), Range::all(),d);
      }
      }
      #pragma omp parallel for private(c,d)
      for(c=X.extent(secondDim)-num_spvar_indep_var; c<X.extent(secondDim); c++) {
              for(d=0; d<images.extent(fifthDim); d++) {
	XTY(Range::all(), Range::all(), Range::all(), Range::all(),c)+=ind_images(Range::all(),Range::all(),Range::all(),Range::all(),c-(X.extent(secondDim)-num_spvar_indep_var),ranIndex(d))*images(Range::all(),Range::all(),Range::all(),Range::all(),d);
      }
      }
  }
  //  end=clock();
  //cout << "computer time2= " << start << "\t" << end << endl;

  // 4/21/2009; Just filled XTXextra (hopefully), go to next step in Cholesky updating stuff

  // do initial Cholesky, to get most of L matrix filled
  XTX=sum( X(k,i)*X(k,j),k);
 
  //  cout << X << endl;
  //  cout << XTX << endl;
  //  cout << L << endl;

  // now populate XTX with new entries and repeat Cholesky at all voxels
 Array<float,2> L(X.extent(secondDim), X.extent(secondDim));
  L=0.;
  if((fin_OK=fchdecomp(XTX,L))!=0) {
    cout << "error in cholesky decomposition, exiting" << endl;
    exit(1);
  }
  #pragma omp parallel for private(a,b,c,d) shared(XTY,tmpb,B,XTXextra)
  for(d=0; d<images.extent(fourthDim); d++) {
    for(c=0; c<images.extent(thirdDim); c++) {
      for(b=0; b<images.extent(secondDim); b++) {
	for(a=0; a<images.extent(firstDim); a++) {
            update_fchdecomp(XTXextra(a,b,c,d,Range::all(),Range::all()),L); //write this!!
	  //forward substitution at voxel
	  if( (fin_OK=fforwardsub_vec(L,XTY(a,b,c,d,Range::all()),tmpb(a,b,c,d,Range::all())) ) !=0) {
	    cout << "error in forward substitution at voxel, exiting" << endl;
	    exit(1);
	  }
	  //now for back substitution and solution
	  if( (fin_OK=fbacksub_vox(L.transpose(secondDim,firstDim),tmpb(a,b,c,d,Range::all()),B(a,b,c,d,Range::all()))) !=0) {
	    cout << "error in back substitution at voxel, exiting" << endl;
	    exit(1);
	  }
	  //	  cout << B(a,b,c,d,Range::all()) << endl;
	}
      }
    }
  }

//  cout << B(0,0,0,Range::all(),Range::all()) << endl;
//  cout << B(19,24,29,Range::all(),Range::all()) << endl;
//  end=clock();
//  cout << "time in cholesky solve " << end-start << endl;
  return(0);
}

int cholesky_solve_static_spvar(Array<float,2> Y, Array<float,6> ind_images,int num_spvar_indep_var,Array<float, 2> X, Array<float,6> XTXextra,Array<float,5> B,Array<int,1> ranIndex, int perm) {
  int fin_OK;
  int a,b,c,d;
  Array<float,2> XTX(X.extent(secondDim),X.extent(secondDim));
  Array<float,2> L(X.extent(secondDim), X.extent(secondDim));
  L=0.;

  firstIndex i;
  secondIndex j;
  thirdIndex k;

  // first add a column to X matrix to initialize; use value from middle of image (try to avoid all zero background)
  for(a=0; a<num_spvar_indep_var; a++) {
    for(b=0; b<X.extent(firstDim); b++) {
      X(b,X.extent(secondDim)-a-1)=ind_images((int)ind_images.extent(firstDim)/2,(int)ind_images.extent(secondDim)/2,(int)ind_images.extent(thirdDim)/2,0,a,b);
    }
  }
//    cout << X << endl;
  

  // create XTY
  Array<float,5> XTY(B.extent(firstDim), B.extent(secondDim), B.extent(thirdDim), B.extent(fourthDim), X.extent(secondDim));
  Array<float,5> tmpb(B.extent(firstDim), B.extent(secondDim), B.extent(thirdDim), B.extent(fourthDim), X.extent(secondDim));
  //  clock_t start, end;
  XTY=0.;
  XTXextra=0.;
   //  start=clock();
  if(perm==0) {
    for(d=0; d<Y.extent(secondDim); d++) {
      for(a=0; a<num_spvar_indep_var; a++) {
	for(c=0; c<X.extent(secondDim)-num_spvar_indep_var; c++) {
	  XTXextra(Range::all(),Range::all(),Range::all(),Range::all(),c,a)+=X(d,c)*ind_images(Range::all(),Range::all(),Range::all(),Range::all(),a,d);
	}
      }
      for(a=0; a<num_spvar_indep_var; a++) {
	for(c=0; c<num_spvar_indep_var; c++) {
	  XTXextra(Range::all(),Range::all(),Range::all(),Range::all(),c+X.extent(secondDim)-num_spvar_indep_var,a)+=ind_images(Range::all(),Range::all(),Range::all(),Range::all(),a,d)*ind_images(Range::all(),Range::all(),Range::all(),Range::all(),c,d);
	}
      }
      for(c=0; c<X.extent(secondDim)-num_spvar_indep_var; c++) {
	XTY(Range::all(), Range::all(), Range::all(), Range::all(),c)+=X(d,c)*Y(0,d);
      }
      for(c=X.extent(secondDim)-num_spvar_indep_var; c<X.extent(secondDim); c++) {
	XTY(Range::all(), Range::all(), Range::all(), Range::all(),c)+=ind_images(Range::all(),Range::all(),Range::all(),Range::all(),c-(X.extent(secondDim)-num_spvar_indep_var),d)*Y(0,d);
      }
    }
  }
  else {
    for(d=0; d<Y.extent(secondDim); d++) {
      for(a=0; a<num_spvar_indep_var; a++) {
	for(c=0; c<X.extent(secondDim)-num_spvar_indep_var; c++) {
	  XTXextra(Range::all(),Range::all(),Range::all(),Range::all(),c,a)+=X(d,c)*ind_images(Range::all(),Range::all(),Range::all(),Range::all(),a,d);
	}
      }
      for(a=0; a<num_spvar_indep_var; a++) {
	for(c=0; c<num_spvar_indep_var; c++) {
	  XTXextra(Range::all(),Range::all(),Range::all(),Range::all(),c+X.extent(secondDim)-num_spvar_indep_var,a)+=ind_images(Range::all(),Range::all(),Range::all(),Range::all(),a,d)*ind_images(Range::all(),Range::all(),Range::all(),Range::all(),c,d);
	}
      }
      for(c=0; c<X.extent(secondDim)-num_spvar_indep_var; c++) {
	XTY(Range::all(), Range::all(), Range::all(), Range::all(),c)+=X(ranIndex(d),c)*Y(0,d);
      }
      for(c=X.extent(secondDim)-num_spvar_indep_var; c<X.extent(secondDim); c++) {
	XTY(Range::all(), Range::all(), Range::all(), Range::all(),c)+=ind_images(Range::all(),Range::all(),Range::all(),Range::all(),c-(X.extent(secondDim)-num_spvar_indep_var),ranIndex(d))*Y(0,d);
      }      
    }
  }
  //  end=clock();
  //cout << "computer time2= " << start << "\t" << end << endl;

  // 4/21/2009; Just filled XTXextra (hopefully), go to next step in Cholesky updating stuff

  // do initial Cholesky, to get most of L matrix filled
  XTX=sum( X(k,i)*X(k,j),k);
 
  if((fin_OK=fchdecomp(XTX,L))!=0) {
    cout << "error in cholesky decomposition, exiting" << endl;
    exit(1);
  }
  //  cout << X << endl;
  //  cout << XTX << endl;
  //  cout << L << endl;

  // now populate XTX with new entries and repeat Cholesky at all voxels
  for(d=0; d<B.extent(fourthDim); d++) {
    for(c=0; c<B.extent(thirdDim); c++) {
      for(b=0; b<B.extent(secondDim); b++) {
	for(a=0; a<B.extent(firstDim); a++) {
	  update_fchdecomp(XTXextra(a,b,c,d,Range::all(),Range::all()),L); //write this!!
	  //forward substitution at voxel
	  if( (fin_OK=fforwardsub_vec(L,XTY(a,b,c,d,Range::all()),tmpb(a,b,c,d,Range::all())) ) !=0) {
	    cout << "error in forward substitution at voxel, exiting" << endl;
	    exit(1);
	  }
	  //now for back substitution and solution
	  if( (fin_OK=fbacksub_vox(L.transpose(secondDim,firstDim),tmpb(a,b,c,d,Range::all()),B(a,b,c,d,Range::all()))) !=0) {
	    cout << "error in back substitution at voxel, exiting" << endl;
	    exit(1);
	  }
	  //	  	  cout << B(a,b,c,d,Range::all()) << endl;
	}
      }
    }
  }
  return(0);
}

int cholesky_solve_mult_static_spvar(Array<float,2> Y, Array<float,6> ind_images,int num_spvar_indep_var,Array<float, 2> X, Array<float,6> XTXextra,Array<float,5> B,Array<int,1> ranIndex, int perm) {
  int fin_OK;
  int a,b,c,d;
  Array<float,2> XTX(X.extent(secondDim),X.extent(secondDim));
  Array<float,2> L(X.extent(secondDim), X.extent(secondDim));
  L=0.;

  firstIndex i;
  secondIndex j;
  thirdIndex k;

  // first add a column to X matrix to initialize; use value from middle of image (try to avoid all zero background)
  for(a=0; a<num_spvar_indep_var; a++) {
    for(b=0; b<X.extent(firstDim); b++) {
      X(b,X.extent(secondDim)-a-1)=ind_images((int)ind_images.extent(firstDim)/2,(int)ind_images.extent(secondDim)/2,(int)ind_images.extent(thirdDim)/2,0,a,b);
    }
  }
  //  cout << X << endl;
  

  // create XTY
  Array<float,6> XTY(B.extent(firstDim), B.extent(secondDim), B.extent(thirdDim), ind_images.extent(fourthDim), Y.extent(firstDim),X.extent(secondDim));
  Array<float,6> tmpb(B.extent(firstDim), B.extent(secondDim), B.extent(thirdDim), ind_images.extent(fourthDim), Y.extent(firstDim),X.extent(secondDim));
  //  clock_t start, end;
  XTY=0.;
  XTXextra=0.;
  tmpb=0.;
   //  start=clock();
  if(perm==0) {
    for(d=0; d<Y.extent(secondDim); d++) {
      for(a=0; a<num_spvar_indep_var; a++) {
	for(c=0; c<X.extent(secondDim)-num_spvar_indep_var; c++) {
	  XTXextra(Range::all(),Range::all(),Range::all(),Range::all(),c,a)+=X(d,c)*ind_images(Range::all(),Range::all(),Range::all(),Range::all(),a,d);
	}
      }
      for(a=0; a<num_spvar_indep_var; a++) {
	for(c=0; c<num_spvar_indep_var; c++) {
	  XTXextra(Range::all(),Range::all(),Range::all(),Range::all(),c+X.extent(secondDim)-num_spvar_indep_var,a)+=ind_images(Range::all(),Range::all(),Range::all(),Range::all(),a,d)*ind_images(Range::all(),Range::all(),Range::all(),Range::all(),c,d);
	}
      }
      for(b=0; b<Y.extent(firstDim); b++) {
	for(c=0; c<X.extent(secondDim)-num_spvar_indep_var; c++) {
	  XTY(Range::all(), Range::all(), Range::all(), Range::all(),b,c)+=X(d,c)*Y(b,d);
	}
	for(c=X.extent(secondDim)-num_spvar_indep_var; c<X.extent(secondDim); c++) {
	  XTY(Range::all(), Range::all(), Range::all(), Range::all(),b,c)+= ind_images(Range::all(),Range::all(),Range::all(),Range::all(),c-num_spvar_indep_var-1,d)*Y(b,d);
	}
      }
    }
  }
  else {
    for(d=0; d<Y.extent(secondDim); d++) {
      for(a=0; a<num_spvar_indep_var; a++) {
	for(c=0; c<X.extent(secondDim)-num_spvar_indep_var; c++) {
	  XTXextra(Range::all(),Range::all(),Range::all(),Range::all(),c,a)+=X(d,c)*ind_images(Range::all(),Range::all(),Range::all(),Range::all(),a,d);
	}
      }
      for(a=0; a<num_spvar_indep_var; a++) {
	for(c=0; c<num_spvar_indep_var; c++) {
	  XTXextra(Range::all(),Range::all(),Range::all(),Range::all(),c+X.extent(secondDim)-num_spvar_indep_var,a)+=ind_images(Range::all(),Range::all(),Range::all(),Range::all(),a,d)*ind_images(Range::all(),Range::all(),Range::all(),Range::all(),c,d);
	}
      }
      for(b=0; b<Y.extent(firstDim); b++) {
	for(c=0; c<X.extent(secondDim)-num_spvar_indep_var; c++) {
	  XTY(Range::all(), Range::all(), Range::all(), Range::all(),b,c)+=X(ranIndex(d),c)*Y(b,d);
	}
	for(c=X.extent(secondDim)-num_spvar_indep_var; c<X.extent(secondDim); c++) {
	  XTY(Range::all(), Range::all(), Range::all(), Range::all(),b,c)+=ind_images(Range::all(),Range::all(),Range::all(),Range::all(),c-num_spvar_indep_var-1,ranIndex(d))*Y(b,d);
	}      
      }
    }
  }
  //  end=clock();
  //cout << "computer time2= " << start << "\t" << end << endl;

  // 4/21/2009; Just filled XTXextra (hopefully), go to next step in Cholesky updating stuff

  // do initial Cholesky, to get most of L matrix filled
  XTX=sum( X(k,i)*X(k,j),k);
  
  if((fin_OK=fchdecomp(XTX,L))!=0) {
    cout << "error in cholesky decomposition, exiting" << endl;
    exit(1);
  }
  //  cout << X << endl;
  //  cout << XTX << endl;
  //  cout << L << endl;

  // now populate XTX with new entries and repeat Cholesky at all voxels
  // right now is zzdim!=1, only solved for first frame

  for(d=0; d<B.extent(fourthDim); d++) {
    for(c=0; c<B.extent(thirdDim); c++) {
      for(b=0; b<B.extent(secondDim); b++) {
	for(a=0; a<B.extent(firstDim); a++) {
	  update_fchdecomp(XTXextra(a,b,c,0,Range::all(),Range::all()),L); //write this!!
	  //forward substitution at voxel
	  if( (fin_OK=fforwardsub_vec(L,XTY(a,b,c,0,d,Range::all()),tmpb(a,b,c,0,d,Range::all())) ) !=0) {
	    cout << "error in forward substitution at voxel, exiting" << endl;
	    exit(1);
	  }
	  //now for back substitution and solution
	  if( (fin_OK=fbacksub_vox(L.transpose(secondDim,firstDim),tmpb(a,b,c,0,d,Range::all()),B(a,b,c,d,Range::all()))) !=0) {
	    cout << "error in back substitution at voxel, exiting" << endl;
	    exit(1);
	  }
	  //	  	  cout << B(a,b,c,d,Range::all()) << endl;
	}
      }
    }
    }
  return(0);
}



int fchdecomp(Array<float,2> A, Array<float,2> L) {
  int a,b;
  L=0.;
  L(0,0)=sqrt(A(0,0));
  for(a=1; a<L.extent(firstDim); a++) {
    L(a,0)=( A(a,0) )/L(0,0);
    for(b=1; b<a; b++) {
      L(a,b)=( A(a,b) - sum(L(a,Range(0,b-1))*L(b,Range(0,b-1))))/L(b,b);
    }
    L(a,a)=sqrt( ( A(a,a)-sum( L(a,Range(0,a-1))*L(a,Range(0,a-1))) ) );
  }
  return(0);
}

int update_fchdecomp(Array<float,2> U, Array<float,2> L) {
  int a,b,c;
  c=L.extent(firstDim)-U.extent(secondDim);
  for(a=c; a<L.extent(firstDim); a++) {
    L(a,0)=( U(0,a-c) / L(0,0) );
    for(b=1; b<a; b++) {
      L(a,b)=( U(b,a-c) - sum(L(a,Range(0,b-1))*L(b,Range(0,b-1))))/L(b,b);
    }
    L(a,a)=sqrt( ( U(a,a-c)-sum( L(a,Range(0,a-1))*L(a,Range(0,a-1))) ) );
  }
  return(0);
}

int fforwardsub(Array<float,2> L, Array<float,5> XTY, Array<float,5> tmpb) {
  int a,b;
  firstIndex i;
  secondIndex j;
  thirdIndex k;
  tmpb(Range::all(), Range::all(), Range::all(), Range::all(),0)=XTY(Range::all(), Range::all(), Range::all(), Range::all(),0)/L(0,0);

  for(a=1; a<XTY.extent(fifthDim); a++) {
    tmpb(Range::all(), Range::all(), Range::all(), Range::all(),a)=XTY(Range::all(), Range::all(), Range::all(), Range::all(),a);
    for(b=0; b<=a-1; b++) {
      tmpb(Range::all(), Range::all(), Range::all(), Range::all(), a) -= tmpb(Range::all(), Range::all(), Range::all(), Range::all(),b)*L(a,b);
    }
    tmpb(Range::all(), Range::all(), Range::all(), Range::all(),a)/=L(a,a);
  }
  return(0);
}

int fbacksub(Array<float, 2> L, Array<float,5> tmpb, Array<float,5> Beta) {
  int a,b,e;

  e=Beta.extent(fifthDim)-1;
  Beta(Range::all(), Range::all(), Range::all(), Range::all(),e)=tmpb(Range::all(), Range::all(), Range::all(), Range::all(),e)/L(e,e);
//#pragma omp parallel for private(a,b)
  for(a=e-1; a>=0; a--) {
    Beta(Range::all(), Range::all(), Range::all(), Range::all(),a)=tmpb(Range::all(), Range::all(), Range::all(), Range::all(), a);
    for(b=a+1; b<=e; b++) {
      Beta(Range::all(), Range::all(), Range::all(), Range::all(),a)-= Beta(Range::all(), Range::all(), Range::all(), Range::all(),b)*L(a,b);
    }
    Beta(Range::all(), Range::all(), Range::all(), Range::all(),a)/=L(a,a);
  }
  return(0);
}

int fbacksub_vox(Array<float,2> L, Array<float,1> tmpb_vox, Array<float,1> Beta_vox) {
  //nothing yet
  int a,b,c;
  c=Beta_vox.extent(firstDim)-1;
  Beta_vox(c)=tmpb_vox(c)/L(c,c);
  for(a=c-1; a>=0; a--) {
    Beta_vox(a)=tmpb_vox(a);
    for(b=a+1; b<=c; b++) {
      Beta_vox(a) -= Beta_vox(b)*L(a,b);
    }
    Beta_vox(a) /= L(a,a);
  }
  return(0);
}

int SSH2make(Array<float,2> X,Array<float,2> invXTX,Array<float,5> Bimage,Array<float,6> SSH2image) {
  int a,b,c;
  firstIndex i;
  secondIndex j;
  thirdIndex k;
  int fin_OK;

  Array<float,4> LB(Bimage.extent(firstDim),Bimage.extent(secondDim),Bimage.extent(thirdDim),Bimage.extent(fourthDim));
  Array<float,5> tmpimage(Bimage.extent(firstDim),Bimage.extent(secondDim),Bimage.extent(thirdDim),Bimage.extent(fourthDim),Bimage.extent(fourthDim));
  Array<float,2> XTX(X.extent(secondDim),X.extent(secondDim));  

  XTX=sum( X(k,i)*X(k,j),k);
  if((fin_OK=invSPD(XTX,invXTX))!=0) {
    cout << "could not invert XTX in SSH2make, exiting" << endl;
    exit(1);
  }
  for(a=1; a<Bimage.extent(fifthDim); a++) {
    LB=0.;
    tmpimage=0.;
    LB(Range::all(),Range::all(),Range::all(),Range::all())=Bimage(Range::all(),Range::all(),Range::all(),Range::all(),a);
    for(b=0; b<LB.extent(fourthDim); b++) {
      for(c=0; c<b; c++) {
	tmpimage(Range::all(),Range::all(),Range::all(),c,b)=LB(Range::all(),Range::all(),Range::all(),b)*LB(Range::all(),Range::all(),Range::all(),c);
	tmpimage(Range::all(),Range::all(),Range::all(),b,c)=tmpimage(Range::all(),Range::all(),Range::all(),c,b);
      }
      tmpimage(Range::all(),Range::all(),Range::all(),b,b)=sqr(LB(Range::all(),Range::all(),Range::all(),b));
    }

    SSH2image(Range::all(),Range::all(),Range::all(),a-1,Range::all(),Range::all())=tmpimage/invXTX(a,a);
  }
  return(0);
}

int SSH2make_spvar(Array<float,6> invXTX_spvar,Array<float,5> Bimage,Array<float,6> SSH2image) {
  int a,b,c;
  firstIndex i;
  secondIndex j;
  thirdIndex k;

  Array<float,4> LB(Bimage.extent(firstDim),Bimage.extent(secondDim),Bimage.extent(thirdDim),Bimage.extent(fourthDim));
  Array<float,5> tmpimage(Bimage.extent(firstDim),Bimage.extent(secondDim),Bimage.extent(thirdDim),Bimage.extent(fourthDim),Bimage.extent(fourthDim));


  for(a=1; a<Bimage.extent(fifthDim); a++) {
    LB=0.;
    tmpimage=0.;
    LB(Range::all(),Range::all(),Range::all(),Range::all())=Bimage(Range::all(),Range::all(),Range::all(),Range::all(),a);
    for(b=0; b<LB.extent(fourthDim); b++) {
      for(c=0; c<b; c++) {
	tmpimage(Range::all(),Range::all(),Range::all(),c,b)=LB(Range::all(),Range::all(),Range::all(),b)*LB(Range::all(),Range::all(),Range::all(),c)/invXTX_spvar(Range::all(),Range::all(),Range::all(),0,a,a);
	tmpimage(Range::all(),Range::all(),Range::all(),b,c)=tmpimage(Range::all(),Range::all(),Range::all(),c,b);
      }
      tmpimage(Range::all(),Range::all(),Range::all(),b,b)=sqr(LB(Range::all(),Range::all(),Range::all(),b))/invXTX_spvar(Range::all(),Range::all(),Range::all(),0,a,a);
    }

    SSH2image(Range::all(),Range::all(),Range::all(),a-1,Range::all(),Range::all())=tmpimage;
  }
  return(0);
}

int SSH2make_multi_spvar(Array<float,2> C1,Array<float,6> invXTX_spvar,Array<float,5> Bimage,Array<float,6> SSH2image) {
  int a,b,c;
  firstIndex i;
  secondIndex j;
  thirdIndex k;

  Array<float,4> CB(Bimage.extent(firstDim),Bimage.extent(secondDim),Bimage.extent(thirdDim),Bimage.extent(fourthDim));
  Array<float,5> tmpimage(Bimage.extent(firstDim),Bimage.extent(secondDim),Bimage.extent(thirdDim),Bimage.extent(fourthDim),Bimage.extent(fourthDim));
  Array<float,5> tmp(Bimage.extent(firstDim),Bimage.extent(secondDim),Bimage.extent(thirdDim),C1.extent(firstDim),C1.extent(secondDim));
  Array<float,5> middle(Bimage.extent(firstDim),Bimage.extent(secondDim),Bimage.extent(thirdDim),C1.extent(firstDim),C1.extent(firstDim));
  tmp=0.; middle=0.;
  for(a=0;a<C1.extent(firstDim); a++) {
    for(b=0; b<C1.extent(secondDim); b++) {
      tmp(Range::all(),Range::all(),Range::all(),a,Range::all())+=C1(a,b)*invXTX_spvar(Range::all(),Range::all(),Range::all(),0,b,Range::all());
    }
  }
  for(a=0;a<C1.extent(firstDim); a++) {
    for(b=0; b<C1.extent(secondDim); b++) {
      middle(Range::all(),Range::all(),Range::all(),Range::all(),a)+=tmp(Range::all(),Range::all(),Range::all(),Range::all(),b)*C1(a,b);
    }
  }

  for(a=0; a<C1.extent(firstDim); a++) { // this increments through number of contrasts
    CB=0.;
    tmpimage=0.;
    for(b=0; b<C1.extent(secondDim); b++) {
      CB(Range::all(),Range::all(),Range::all(),Range::all()) += C1(a,b)*Bimage(Range::all(),Range::all(),Range::all(),Range::all(),b);

    }
    // create CB'*CB    
    for(b=0; b<CB.extent(fourthDim); b++) {
      for(c=0; c<b; c++) {
	tmpimage(Range::all(),Range::all(),Range::all(),c,b)=CB(Range::all(),Range::all(),Range::all(),b)*CB(Range::all(),Range::all(),Range::all(),c)/middle(Range::all(),Range::all(),Range::all(),a,a);
	tmpimage(Range::all(),Range::all(),Range::all(),b,c)=tmpimage(Range::all(),Range::all(),Range::all(),c,b);
      }
      tmpimage(Range::all(),Range::all(),Range::all(),b,b)=sqr(CB(Range::all(),Range::all(),Range::all(),b))/middle(Range::all(),Range::all(),Range::all(),a,a);
    }

    SSH2image(Range::all(),Range::all(),Range::all(),a,Range::all(),Range::all())=tmpimage;
  }
  return(0);
}

int SSH2make_multi(Array<float,2> C1,Array<float,2> invXTX,Array<float,5> Bimage,Array<float,6> SSH2image) {
  int a,b,c;
  firstIndex i;
  secondIndex j;
  thirdIndex k;

  Array<float,4> CB(Bimage.extent(firstDim),Bimage.extent(secondDim),Bimage.extent(thirdDim),Bimage.extent(fourthDim));
  Array<float,5> tmpimage(Bimage.extent(firstDim),Bimage.extent(secondDim),Bimage.extent(thirdDim),Bimage.extent(fourthDim),Bimage.extent(fourthDim));
  Array<float,2> tmp(invXTX.extent(firstDim),C1.extent(firstDim));
  Array<float,2> middle(C1.extent(firstDim),C1.extent(firstDim));

  tmp=sum(invXTX(i,k)*C1(j,k),k);
  middle=sum(C1(i,k)*tmp(k,j),k);

  for(a=0; a<C1.extent(firstDim); a++) { // this increments through number of contrasts
    CB=0.;
    tmpimage=0.;
    for(b=0; b<C1.extent(secondDim); b++) {
      CB(Range::all(),Range::all(),Range::all(),Range::all()) += C1(a,b)*Bimage(Range::all(),Range::all(),Range::all(),Range::all(),b);

    }
    // create CB'*CB    
    for(b=0; b<CB.extent(fourthDim); b++) {
      for(c=0; c<b; c++) {
	tmpimage(Range::all(),Range::all(),Range::all(),c,b)=CB(Range::all(),Range::all(),Range::all(),b)*CB(Range::all(),Range::all(),Range::all(),c);
	tmpimage(Range::all(),Range::all(),Range::all(),b,c)=tmpimage(Range::all(),Range::all(),Range::all(),c,b);
      }
      tmpimage(Range::all(),Range::all(),Range::all(),b,b)=sqr(CB(Range::all(),Range::all(),Range::all(),b));
    }

    SSH2image(Range::all(),Range::all(),Range::all(),a,Range::all(),Range::all())=tmpimage/middle(a,a);
  }
  return(0);
}

int SSResids(Array<float,5> images, Array<float,2> X, Array<float,5> Bimage, Array<float,5> SSHimage,Array<int,1> ranIndex,int perm) {
  int a,b,c;
  Array<float,4> tmpfit1(images.extent(firstDim),images.extent(secondDim),images.extent(thirdDim),images.extent(fourthDim));

  SSHimage=0.;  
  for(c=0; c<images.extent(fifthDim); c++) {
      tmpfit1=0.;
      if(perm==0) {
        for(b=0; b<X.extent(secondDim); b++) {
              tmpfit1(Range::all(),Range::all(),Range::all(),Range::all()) -= X(c,b)*Bimage(Range::all(),Range::all(),Range::all(),Range::all(),b);
        }
      }
      else {
        for(b=0; b<X.extent(secondDim); b++) {
              tmpfit1(Range::all(),Range::all(),Range::all(),Range::all()) -= X(ranIndex(c),b)*Bimage(Range::all(),Range::all(),Range::all(),Range::all(),b);
        }
      }
      tmpfit1+=images(Range::all(),Range::all(),Range::all(),Range::all(),c);
      for(b=0; b<SSHimage.extent(fifthDim);b++) {
          SSHimage(Range::all(),Range::all(),Range::all(),b,b)+=pow(tmpfit1(Range::all(),Range::all(),Range::all(),b),2);
      }
      for(a=1; a<SSHimage.extent(fourthDim); a++) {
        for(b=0; b<a; b++) {
          SSHimage(Range::all(),Range::all(),Range::all(),a,b)+=tmpfit1(Range::all(),Range::all(),Range::all(),b)*tmpfit1(Range::all(),Range::all(),Range::all(),a);
        }
      }
  }
  for(a=1; a<SSHimage.extent(fourthDim);a++) {
      for(b=0; b<a; b++) {
          SSHimage(Range::all(),Range::all(),Range::all(),b,a)=SSHimage(Range::all(),Range::all(),Range::all(),a,b);
      } 
  } 
  return(0);
}


int SSResids_static(Array<float,2> Y, Array<float,2> X, Array<float,5> Bimage, Array<float,5> SSHimage,Array<int,1> ranIndex,int perm) {
  int a,b,c;
  Array<float,4> tmpfit1(Bimage.extent(firstDim),Bimage.extent(secondDim),Bimage.extent(thirdDim),Bimage.extent(fourthDim));

  SSHimage=0.;
  for(c=0; c<Y.extent(secondDim); c++) {
      tmpfit1=0.;
      if(perm==0) {
        for(b=0; b<X.extent(secondDim); b++) {
              tmpfit1(Range::all(),Range::all(),Range::all(),Range::all()) -= X(c,b)*Bimage(Range::all(),Range::all(),Range::all(),Range::all(),b);
        }
      }
      else {
        for(b=0; b<X.extent(secondDim); b++) {
              tmpfit1(Range::all(),Range::all(),Range::all(),Range::all()) -= X(ranIndex(c),b)*Bimage(Range::all(),Range::all(),Range::all(),Range::all(),b);
        }
      }
      for(b=0; b<Y.extent(firstDim);b++) tmpfit1(Range::all(),Range::all(),Range::all(),b)+=Y(b,c);
      for(b=0; b<SSHimage.extent(fifthDim);b++) {
          SSHimage(Range::all(),Range::all(),Range::all(),b,b)+=pow(tmpfit1(Range::all(),Range::all(),Range::all(),b),2);
      }
      for(a=1; a<SSHimage.extent(fourthDim); a++) {
        for(b=0; b<a; b++) {
          SSHimage(Range::all(),Range::all(),Range::all(),a,b)+=tmpfit1(Range::all(),Range::all(),Range::all(),b)*tmpfit1(Range::all(),Range::all(),Range::all(),a);
        }
      }
  }
  for(a=1; a<SSHimage.extent(fourthDim);a++) {
      for(b=0; b<a; b++) {
          SSHimage(Range::all(),Range::all(),Range::all(),b,a)=SSHimage(Range::all(),Range::all(),Range::all(),a,b);
      }
  }
  return(0);
}


int SSResids_spvar(Array<float,5> images, Array<float,6> ind_images,int num_spvar_indep_var,Array<float,2> X, Array<float,5> Bimage, Array<float,5> SSHimage,Array<int,1> ranIndex,int perm) {
  int a,b,c;
  Array<float,4> tmpfit1(images.extent(firstDim),images.extent(secondDim),images.extent(thirdDim),images.extent(fourthDim));

  SSHimage=0.;
  for(c=0; c<images.extent(fifthDim); c++) {
      tmpfit1=0.;
      if(perm==0) {
        for(b=0; b<X.extent(secondDim)-num_spvar_indep_var; b++) {
              tmpfit1(Range::all(),Range::all(),Range::all(),Range::all()) -= X(c,b)*Bimage(Range::all(),Range::all(),Range::all(),Range::all(),b);
        }
      // now compute for spatially varying columns of X
        for(b=X.extent(secondDim)-num_spvar_indep_var; b<X.extent(secondDim); b++) {
	      tmpfit1(Range::all(),Range::all(),Range::all(),Range::all())-=ind_images(Range::all(),Range::all(),Range::all(),Range::all(),b-(X.extent(secondDim)-num_spvar_indep_var),c)*Bimage(Range::all(),Range::all(),Range::all(),Range::all(),b);
        }
      }
      else {
        for(b=0; b<X.extent(secondDim)-num_spvar_indep_var; b++) {
              tmpfit1(Range::all(),Range::all(),Range::all(),Range::all()) -= X(ranIndex(c),b)*Bimage(Range::all(),Range::all(),Range::all(),Range::all(),b);
        }
      // now compute for spatially varying columns of X
        for(b=X.extent(secondDim)-num_spvar_indep_var; b<X.extent(secondDim); b++) {
	      tmpfit1(Range::all(),Range::all(),Range::all(),Range::all())-=ind_images(Range::all(),Range::all(),Range::all(),Range::all(),b-(X.extent(secondDim)-num_spvar_indep_var),ranIndex(c))*Bimage(Range::all(),Range::all(),Range::all(),Range::all(),b);
        }
      }
      tmpfit1+=images(Range::all(),Range::all(),Range::all(),Range::all(),c);
      for(b=0; b<SSHimage.extent(fifthDim);b++) {
          SSHimage(Range::all(),Range::all(),Range::all(),b,b)+=pow(tmpfit1(Range::all(),Range::all(),Range::all(),b),2);
      }
      for(a=1; a<SSHimage.extent(fourthDim); a++) {
        for(b=0; b<a; b++) {
          SSHimage(Range::all(),Range::all(),Range::all(),a,b)+=tmpfit1(Range::all(),Range::all(),Range::all(),b)*tmpfit1(Range::all(),Range::all(),Range::all(),a);
        }
      }
  }
  for(a=1; a<SSHimage.extent(fourthDim);a++) {
      for(b=0; b<a; b++) {
          SSHimage(Range::all(),Range::all(),Range::all(),b,a)=SSHimage(Range::all(),Range::all(),Range::all(),a,b);
      }
  }
  return(0);
}

int SSResids_spvar_static(Array<float,2> Y, Array<float,6> ind_images,int num_spvar_indep_var,Array<float,2> X, Array<float,5> Bimage, Array<float,5> SSHimage,Array<int,1> ranIndex,int perm) {
  int a,b,c;
  Array<float,4> tmpfit1(Bimage.extent(firstDim),Bimage.extent(secondDim),Bimage.extent(thirdDim),Bimage.extent(fourthDim));

  SSHimage=0.;
  for(c=0; c<Y.extent(secondDim); c++) {
      tmpfit1=0.;
      if(perm==0) {
        for(b=0; b<X.extent(secondDim)-num_spvar_indep_var; b++) {
              tmpfit1(Range::all(),Range::all(),Range::all(),Range::all()) -= X(c,b)*Bimage(Range::all(),Range::all(),Range::all(),Range::all(),b);
        }
      // now compute for spatially varying columns of X
        for(b=0; b<Y.extent(firstDim); b++) {
            for(a=X.extent(secondDim)-num_spvar_indep_var; a<X.extent(secondDim); a++) {
                tmpfit1(Range::all(),Range::all(),Range::all(),b)-=ind_images(Range::all(),Range::all(),Range::all(),0,a-(X.extent(secondDim)-num_spvar_indep_var),c)*Bimage(Range::all(),Range::all(),Range::all(),b,a);
            }
        }
      }
      else {
        for(b=0; b<X.extent(secondDim)-num_spvar_indep_var; b++) {
              tmpfit1(Range::all(),Range::all(),Range::all(),Range::all()) -= X(ranIndex(c),b)*Bimage(Range::all(),Range::all(),Range::all(),Range::all(),b);
        }
      // now compute for spatially varying columns of X
        for(b=0; b<Y.extent(firstDim); b++) {
            for(a=X.extent(secondDim)-num_spvar_indep_var; a<X.extent(secondDim); a++) {
                tmpfit1(Range::all(),Range::all(),Range::all(),b)-=ind_images(Range::all(),Range::all(),Range::all(),0,a-(X.extent(secondDim)-num_spvar_indep_var),ranIndex(c))*Bimage(Range::all(),Range::all(),Range::all(),b,a);
            }
        }
      }
      for(b=0; b<Y.extent(firstDim);b++) tmpfit1(Range::all(),Range::all(),Range::all(),b)+=Y(b,c);
      for(b=0; b<SSHimage.extent(fifthDim);b++) {
          SSHimage(Range::all(),Range::all(),Range::all(),b,b)+=pow(tmpfit1(Range::all(),Range::all(),Range::all(),b),2);
      }
      for(a=1; a<SSHimage.extent(fourthDim); a++) {
        for(b=0; b<a; b++) {
          SSHimage(Range::all(),Range::all(),Range::all(),a,b)+=tmpfit1(Range::all(),Range::all(),Range::all(),b)*tmpfit1(Range::all(),Range::all(),Range::all(),a);
        }
      }
  }
  for(a=1; a<SSHimage.extent(fourthDim);a++) {
      for(b=0; b<a; b++) {
          SSHimage(Range::all(),Range::all(),Range::all(),b,a)=SSHimage(Range::all(),Range::all(),Range::all(),a,b);
      }
  }
    return(0);
}


int calc_F_image(Array<float,5> SSHimage,Array<float,5> SSEimage,Array<float,3> Stat_image, int p,int v, int q,float *df1, float *df2) {
  float r,u,t;
  int fin_OK;
  Array<float,3> detSSH(SSHimage.extent(firstDim),SSHimage.extent(secondDim),SSHimage.extent(thirdDim));
  Array<float,3> detSSE(SSEimage.extent(firstDim),SSEimage.extent(secondDim),SSEimage.extent(thirdDim));
//  Array<float,3> lambda(SSEimage.extent(firstDim),SSEimage.extent(secondDim),SSEimage.extent(thirdDim));
  if(SSHimage.extent(fourthDim)>1){
    fin_OK=determSPD(SSHimage,detSSH);
    if(fin_OK!=0) {
      cout << "ERROR computing determinant of SSHimage, exiting " << endl;
      exit(1);
    }
    fin_OK=determSPD(SSEimage,detSSE);
    if(fin_OK!=0) {
      cout << "ERROR computing determinant of SSHimage, exiting " << endl;
      exit(1);
    }
  }
  else {
    detSSH(Range::all(),Range::all(),Range::all())=SSHimage(Range::all(),Range::all(),Range::all(),0,0);
    detSSE(Range::all(),Range::all(),Range::all())=SSEimage(Range::all(),Range::all(),Range::all(),0,0);
  }
  // add zeros to detSSE and detSSH so I don't divide by zero anywhere
  detSSE=where(detSSE==0 && detSSH==0,detSSE+1,detSSE);
  detSSH=where(detSSH==0 && detSSH==0,detSSH+1,detSSH);
  //  detSSE=where(detSSE==0, detSSE+1, detSSE);
  //  detSSH=where(detSSH==0, detSSH+1, detSSH);
//  lambda=detSSE/detSSH;

  // using lambda to F calculation described in SAS documentation
  // p=number of dependent variables
  // q=num of variables of interest
  // v=error degrees of freedom, number_scans-num_effects-num_confounds

  r=(float)v-((p-q+1)/2.);
  u=(p*q-2.)/4.;
  if( (p*p+q*q-5>0)) t=sqrt( (p*p*q*q-4.)/(p*p+q*q-5.) );
  else t=1.;
  *df1=p*q;
  *df2=(r*t-2.*u);
  Stat_image=(1-pow((detSSE/detSSH)/*lambda*/,(1/t)))/pow((detSSE/detSSH)/*lambda*/,(1/t))*( *df2/ *df1);
  return(0);
}

int calc_F_image_multi(Array<float,5> SSHimage,Array<float,5> SSEimage,Array<float,3> detSSE,Array<float,6> SSH2image,Array<float,3> Stat_image, Array<float,4> FStat_Manova,int p,int v, int q,float *df1, float *df2, float *df3, float *df4) {
  float r,u,t;
  int fin_OK,a;
  Array<float,3> detSSH(SSHimage.extent(firstDim),SSHimage.extent(secondDim),SSHimage.extent(thirdDim));
//  Array<float,3> lambda(SSEimage.extent(firstDim),SSEimage.extent(secondDim),SSEimage.extent(thirdDim));

  if(SSHimage.extent(fourthDim)>1){
    fin_OK=determSPD(SSHimage,detSSH);
     if(fin_OK!=0) {
      cout << "ERROR computing determinant of SSHimage, exiting " << endl;
      exit(1);
    }
    fin_OK=determSPD(SSEimage,detSSE);
    if(fin_OK!=0) {
      cout << "ERROR computing determinant of SSHimage, exiting " << endl;
      exit(1);
    }
  }
  else {
    detSSH(Range::all(),Range::all(),Range::all())=SSHimage(Range::all(),Range::all(),Range::all(),0,0);
    detSSE(Range::all(),Range::all(),Range::all())=SSEimage(Range::all(),Range::all(),Range::all(),0,0);
  }
  // add zeros to detSSE and detSSH so I don't divide by zero anywhere
  detSSE=where(detSSE==0 ,detSSE+1,detSSE);
  detSSH=where(detSSH==0 ,detSSH+1,detSSH);
  //  detSSE=where(detSSE==0, detSSE+1, detSSE);
  //  detSSH=where(detSSH==0, detSSH+1, detSSH);
  //lambda=detSSE/detSSH;
 
  // using lambda to F calculation described in SAS documentation
  // p=number of dependent variables
  // q=num of variables of interest
  // v=error degrees of freedom, number_scans-num_effects-num_confounds

  r=(float)v-((p-q+1)/2.);
  u=(p*q-2.)/4.;
  if( (p*p+q*q-5>0)) t=sqrt( (p*p*q*q-4.)/(p*p+q*q-5.) );
  else t=1.;
  *df1=p*q;
  *df2=(r*t-2.*u);
  Stat_image=(1-pow( (detSSE/detSSH)/*lambda*/,(1/t)))/pow( (detSSE/detSSH)/*lambda*/,(1/t))*( *df2/ *df1);

  // NOW, need to compute lambda for each independent variable, to determine if each variable has an effect
  // on the all the dependent variables 
  // use relation, H = M'(LB)'(L(X'X)-1L')-1(LB)M, E=SSE already calculated
  // lambda=det(E)/det(H+E)

  // already have detSSE; for each independent variable need to calculate det(H+E)
  // Array<float,5> tmpimage(SSEimage.extent(firstDim),SSEimage.extent(secondDim),SSEimage.extent(thirdDim),SSEimage.extent(fourthDim),SSEimage.extent(fifthDim));
  // also need to adjust degrees of freedom here,
  // q=1, because I'm looking at F-stat for one variable at a time
  q=1;
  r=(float)v-((p-q+1)/2.);
  u=(p*q-2.)/4.;
  if( (p*p+q*q-5>0)) t=sqrt( (p*p*q*q-4.)/(p*p+q*q-5.) );
  else t=1.;
  *df3=p*q;
  *df4=(r*t-2.*u);

  // caution here--this will destroy the contents of SSHimage, but don't think I need it anymore and will save space
  for(a=0; a<SSH2image.extent(fourthDim); a++) {
//    tmpimage=SSEimage+SSH2image(Range::all(),Range::all(),Range::all(),a,Range::all(),Range::all());
    SSHimage=SSEimage+SSH2image(Range::all(),Range::all(),Range::all(),a,Range::all(),Range::all());
//    fin_OK=determSPD(tmpimage,detSSH);
    fin_OK=determSPD(SSHimage,detSSH);
     if(fin_OK!=0) {
      cout << "ERROR computing determinant of SSHimage, exiting " << endl;
      exit(1);
    }
  // add zeros to detSSE and detSSH so I don't divide by zero anywhere
  detSSH=where(detSSH==0 ,detSSH+1,detSSH);
  //  detSSE=where(detSSE==0, detSSE+1, detSSE);
  //  detSSH=where(detSSH==0, detSSH+1, detSSH);
//  lambda=detSSE/detSSH;
  //  cout << lambda(0,0,0) << endl;
  // now convert to F-statistic
  FStat_Manova(Range::all(),Range::all(),Range::all(),a)=(1-pow( (detSSE/detSSH)/*lambda*/,(1/t)))/pow( (detSSE/detSSH)/*lambda*/,(1/t))*( *df4/ *df3);
  //  cout << FStat_Manova(0,0,0,a) << "\t" << *df3 <<"\t" << *df4 << endl;
  }
  return(0);
}

int calc_contrast_images_multi(Array<float,5> SSEimage,Array<float,5> SSHimage,Array<float,6> SSH2image,Array<float,3> detSSE,Array<float,4> F_contrast_image_multi,int p,float *df3,float *df4) {
  float t,q;
  int a, fin_OK;
  q=1.;
  if( (p*p+q*q-5>0)) t=sqrt( (p*p*q*q-4.)/(p*p+q*q-5.) );
  else t=1.;

//  Array<float,5> tmpimage(SSEimage.extent(firstDim),SSEimage.extent(secondDim),SSEimage.extent(thirdDim),SSEimage.extent(fourthDim),SSEimage.extent(fifthDim));
  Array<float,3> detSSH(SSH2image.extent(firstDim),SSH2image.extent(secondDim),SSH2image.extent(thirdDim));
//  Array<float,3> lambda(SSH2image.extent(firstDim),SSH2image.extent(secondDim),SSH2image.extent(thirdDim));

  for(a=0; a<SSH2image.extent(fourthDim); a++) {
//    tmpimage=SSEimage+SSH2image(Range::all(),Range::all(),Range::all(),a,Range::all(),Range::all());
//    fin_OK=determSPD(tmpimage,detSSH);
    SSHimage=SSEimage+SSH2image(Range::all(),Range::all(),Range::all(),a,Range::all(),Range::all());
    fin_OK=determSPD(SSHimage,detSSH);

    if(fin_OK!=0) {
      cout << "ERROR computing determinant of SSH image in multi contrast images, exiting " << endl;
      exit(1);
    }
    detSSH=where(detSSH==0, detSSH+1, detSSH);
  //  lambda=detSSE/detSSH;
    F_contrast_image_multi(Range::all(),Range::all(),Range::all(),a)=(1-pow( (detSSE/detSSH)/*lambda*/,(1/t)))/pow( (detSSE/detSSH) /*lambda*/,(1/t))*( *df4/ *df3);
  }
  return(0);
}



// 5/22/08: this compiles without error but has not been tested
int determSPD(Array<float,5> image_matrix, Array<float,3> image_det) {
  int fin,a,b,c,d;
  if(image_matrix.extent(fourthDim)==2) {
    image_det(Range::all(),Range::all(),Range::all())=(image_matrix(Range::all(),Range::all(),Range::all(),0,0)*image_matrix(Range::all(),Range::all(),Range::all(),1,1))-(image_matrix(Range::all(),Range::all(),Range::all(),1,0)*image_matrix(Range::all(),Range::all(),Range::all(),0,1));
  }
  else {
    image_det=1.;
    Array<float,2> L(image_matrix.extent(fourthDim),image_matrix.extent(fifthDim));
    for(a=0; a<image_matrix.extent(firstDim); a++) {
        for(b=0; b<image_matrix.extent(secondDim);b++) {
            for(c=0; c<image_matrix.extent(thirdDim); c++) {
                if( (fin=fchdecomp(image_matrix(a,b,c,Range::all(),Range::all()),L))!=0) {
                    cout << "ERROR: in cholesky decomp within determSPD, exiting" << endl;
                    exit(1);
                }
                // now determinant is product of diagonal of L
                for(d=0; d<L.extent(firstDim);d++) {
                    image_det(a,b,c)*= (L(d,d)*L(d,d));
                }
            }
        }
    }
    }
  return(0);
}

// 5/22/08: this compiles without error but has not been tested
int fchdecomp_image(Array<float,5> A, Array<float,5> L) {
  int a,b,c;
  L=0.;
  L(Range::all(),Range::all(),Range::all(),0,0)=sqrt(A(Range::all(),Range::all(),Range::all(),0,0));
  for(a=1; a<L.extent(fourthDim); a++) {
    L(Range::all(),Range::all(),Range::all(),a,0)=( A(Range::all(),Range::all(),Range::all(),a,0) )/L(Range::all(),Range::all(),Range::all(),0,0);
    for(b=1; b<a; b++) {
      L(Range::all(),Range::all(),Range::all(),a,b)=A(Range::all(),Range::all(),Range::all(),a,b);
      for(c=0; c<b; c++) {
	L(Range::all(),Range::all(),Range::all(),a,b)-=L(Range::all(),Range::all(),Range::all(),a,c)*L(Range::all(),Range::all(),Range::all(),b,c);
	}
      L(Range::all(),Range::all(),Range::all(),a,b)/=L(Range::all(),Range::all(),Range::all(),b,b);
    }
    L(Range::all(),Range::all(),Range::all(),a,a)=A(Range::all(),Range::all(),Range::all(),a,a);
    for(c=0; c<a; c++) {
      L(Range::all(),Range::all(),Range::all(),a,a)-= L(Range::all(),Range::all(),Range::all(),a,c)*L(Range::all(),Range::all(),Range::all(),a,c);
      }
    L(Range::all(),Range::all(),Range::all(),a,a)=sqrt(L(Range::all(),Range::all(),Range::all(),a,a));
    }
  return(0);
}

int calc_param_image(Array<float,5> Bimage,Array<float,5> SSEimage,Array<float,5> Stat_param_image,Array<float,2> X,Array<float,2> invXTX, float *df) {
  int a,fin_OK;
  Array<float,2> XTX(X.extent(secondDim),X.extent(secondDim));
  Array<float,4> varImage(Bimage.extent(firstDim),Bimage.extent(secondDim),Bimage.extent(thirdDim),Bimage.extent(fourthDim));
  firstIndex i;
  secondIndex j;
  thirdIndex k;

  XTX=sum( X(k,i)*X(k,j),k);
  if( (fin_OK=invSPD(XTX,invXTX))!=0) {
    cout << "ERROR: could not invert SPD matrix, exiting" << endl;
    exit(1);
  }
  for(a=0; a<SSEimage.extent(fourthDim); a++) {
    varImage(Range::all(),Range::all(),Range::all(),a)=SSEimage(Range::all(),Range::all(),Range::all(),a,a);
  }
  for(a=0; a<Bimage.extent(fifthDim); a++) {
    Stat_param_image(Range::all(),Range::all(),Range::all(),Range::all(),a)=Bimage(Range::all(),Range::all(),Range::all(),Range::all(),a)/ sqrt( varImage*invXTX(a,a)/ *df);
  }
  return(0);
}

int calc_param_image_spvar(Array<float,5> Bimage,Array<float,5> SSEimage,Array<float,5> Stat_param_image,Array<float,6> invXTX_spvar,float *df) {
  Array<float,4> varImage(Bimage.extent(firstDim),Bimage.extent(secondDim),Bimage.extent(thirdDim),Bimage.extent(fourthDim));
  firstIndex i;
  secondIndex j;
  thirdIndex k;
  int a,e;
  
  for(a=0; a<SSEimage.extent(fourthDim); a++) {
    varImage(Range::all(),Range::all(),Range::all(),a)=SSEimage(Range::all(),Range::all(),Range::all(),a,a);
  }

  // now create Stat_param_image at all voxels 
  for(e=0; e<Bimage.extent(fifthDim); e++) {
    Stat_param_image(Range::all(),Range::all(),Range::all(),Range::all(),e)=Bimage(Range::all(),Range::all(),Range::all(),Range::all(),e)/ sqrt( varImage*invXTX_spvar(Range::all(),Range::all(),Range::all(),Range::all(),e,e)/ *df);
  }
  //  cout << Bimage(0,0,0,0,Range::all()) << endl;
  //  cout << varImage(0,0,0,0) << endl;
  //  cout << invXTX_spvar(0,0,0,0,Range::all(),Range::all()) << endl;
  return(0);
}

int calc_param_image_spvar_multi(Array<float,5> Bimage,Array<float,5> SSEimage,Array<float,5> Stat_param_image,Array<float,6> invXTX_spvar,float *df) {
  Array<float,4> varImage(Bimage.extent(firstDim),Bimage.extent(secondDim),Bimage.extent(thirdDim),Bimage.extent(fourthDim));
  firstIndex i;
  secondIndex j;
  thirdIndex k;
  int a,e;
  
  for(a=0; a<SSEimage.extent(fourthDim); a++) {
    varImage(Range::all(),Range::all(),Range::all(),a)=SSEimage(Range::all(),Range::all(),Range::all(),a,a);
  }

  // now create Stat_param_image at all voxels 
  for(e=0; e<Bimage.extent(fifthDim); e++) {
    for(a=0; a<Bimage.extent(fourthDim); a++) {
      Stat_param_image(Range::all(),Range::all(),Range::all(),a,e)=Bimage(Range::all(),Range::all(),Range::all(),a,e)/ sqrt( varImage(Range::all(),Range::all(),Range::all(),a)*invXTX_spvar(Range::all(),Range::all(),Range::all(),0,e,e)/ *df);
    }
  }
  return(0);
}

int invSPD(Array<float,2> X, Array<float,2> invX) {
  int fin_OK,a, no_inverse=0;
  firstIndex i;
  secondIndex j;
  thirdIndex k;

  Array<float,2> L(X.extent(secondDim),X.extent(secondDim));
  Array<float,2> invL(X.extent(secondDim),X.extent(secondDim));
  L=0;
  invL=0;  
  if((fin_OK=fchdecomp(X,L))!=0) {
    cout << "ERROR in cholesky decomp of SPD matrix, exiting" << endl;
    exit(1);
  }
  for(a=0; a<X.extent(firstDim); a++) {
    if(L(a,a)==0) no_inverse=1;
  }
  if(no_inverse==1) {
    cout << "SPD matrix is not invertible, exiting" << endl;
    exit(1);
  }
  else {
    if( (fin_OK=inv_lower(L,invL))!=0) {
      cout << "ERROR: could not invert lower triangular matrix, exiting" << endl;
      exit(1);
    }
    invX=sum( invL(k,i)*invL(k,j),k);
  }
  return(0);
}

int invSPD_spvar(Array<float,2> X,Array<float,6> XTXextra,Array<float,6> invXTX_spvar) {
  int fin_OK,no_inverse=0;
  int a,b,c,d,e;
  firstIndex i;
  secondIndex j;
  thirdIndex k;

  Array<float,2> L(X.extent(secondDim),X.extent(secondDim));
  Array<float,2> invL(X.extent(secondDim),X.extent(secondDim));  
  Array<float,2> invX(X.extent(secondDim),X.extent(secondDim));
  L=0.; 
  invL=0.;  
  if((fin_OK=fchdecomp(X,L))!=0) {
    cout << "ERROR in cholesky decomp of SPD matrix, exiting" << endl;
    exit(1);
  }

  for(d=0; d<XTXextra.extent(fourthDim); d++) {
    for(c=0; c<XTXextra.extent(thirdDim); c++) {
      for(b=0; b<XTXextra.extent(secondDim); b++) {
	for(a=0; a<XTXextra.extent(firstDim); a++) {
	  if(all(XTXextra(a,b,c,d,Range::all(),Range::all())>0.000001)) {
	    update_fchdecomp(XTXextra(a,b,c,d,Range::all(),Range::all()),L);
	    for(e=0; e<X.extent(firstDim); e++) {
	      if(L(e,e)==0) no_inverse=1;
	    }
	    if(no_inverse==1) {
	      cout << "SPD matrix is not invertible" << endl;
	      cout << " a b c d: " << a << "\t" << b << "\t" << c << "\t" << d << endl;
	      cout << XTXextra(a,b,c,d,Range::all(),Range::all()) << endl;
              cout << "Exiting" << endl;
	      exit(1);
	    }
	    else {
	      if( (fin_OK=inv_lower(L,invL))!=0) {
		cout << "ERROR: could not invert lower triangular matrix, exiting" << endl;
		exit(1);
	      }
	      invXTX_spvar(a,b,c,d,Range::all(),Range::all())=sum( invL(k,i)*invL(k,j),k);
	    }
	  }
	  else invXTX_spvar(a,b,c,d,Range::all(),Range::all())=1000000.;
	}
      }
    }
  }
  return(0);
}

int inv_lower(Array<float,2> L, Array<float,2> invL) {
  int a, finOK;
  //  cout << L.extent(firstDim) << endl;
  if(L.extent(firstDim)==2) {
    invL(0,0)=1./L(0,0);
    invL(1,1)=1./L(1,1);
    invL(1,0)=-1.*L(1,0)/(L(0,0)*L(1,1));
    //    cout << invL << endl;
  }
  else {
    Array<float,1> vec(L.extent(firstDim));
    for(a=0; a<L.extent(firstDim); a++) {
      vec=0;
      vec(a)=1.;
      if( (finOK=fforwardsub_vec(L,vec,invL(Range::all(),a)))!=0) {
	cout << "ERROR in forward substitution for vector, exiting" << endl;
	exit(1);
      }
    }
  }
  return(0);
}
			 
int fforwardsub_vec(Array<float,2> L, Array<float,1> vec, Array<float,1> beta) {
  int a;
  beta(0)=vec(0)/L(0,0);
  for(a=1; a<vec.extent(firstDim); a++) {
    beta(a)=( vec(a) - sum( L(a,Range(0,a-1))*beta(Range(0,a-1))) )/L(a,a);
  }
  return(0);
}

int calc_R2_image(Array<float,5> SSEimage,Array<float,5> SSHimage,Array<float,4> R2image) {
  int a;
  for(a=0; a<R2image.extent(fourthDim); a++) {
    R2image(Range::all(),Range::all(),Range::all(),a)=(1. - SSEimage(Range::all(),Range::all(),Range::all(),a,a)/SSHimage(Range::all(),Range::all(),Range::all(),a,a));
  }
  return(0);
}

// calculate estimates and F-statistics for contrasts, if any
int calc_contrast_images(Array<float,2> C1, Array<float,2> invXTX, Array<float,5> Bimage,Array<float,5> SSEimage,Array<float,5> Contrast_image,Array<float,5> F_contrast_image,float *df) {
  int a,b,c;
  firstIndex i;
  secondIndex j;
  thirdIndex k;
  Array<float,2> tmp(invXTX.extent(firstDim),C1.extent(firstDim));
  Array<float,2> middle(C1.extent(firstDim),C1.extent(firstDim));
  Contrast_image=0.;
  F_contrast_image=1.;
  // create contrast estimates
   tmp=sum(invXTX(i,k)*C1(j,k),k);
   middle=sum(C1(i,k)*tmp(k,j),k);
   for(b=0; b<Bimage.extent(fourthDim); b++) {
      for(c=0; c<C1.extent(firstDim); c++) {
	F_contrast_image(Range::all(),Range::all(),Range::all(),b,c)/=SSEimage(Range::all(),Range::all(),Range::all(),b,b);
	for(a=0; a<C1.extent(secondDim); a++) {
	  Contrast_image(Range::all(),Range::all(),Range::all(),b,c)+=C1(c,a)*Bimage(Range::all(),Range::all(),Range::all(),b,a);

	}
      }
  }
  F_contrast_image*=(Contrast_image*Contrast_image*(float)*df);
  for(a=0; a<C1.extent(firstDim); a++) {
    F_contrast_image(Range::all(),Range::all(),Range::all(),Range::all(),a)/=middle(a,a);
  }
   return(0);
}

int calc_contrast_images_spvar(Array<float,2> C1, Array<float,6> invXTX_spvar, Array<float,5> Bimage,Array<float,5> SSEimage,Array<float,5> Contrast_image,Array<float,5> F_contrast_image,float *df) {
  int a,b,c;
  int d,e,f,g;
  firstIndex i;
  secondIndex j;
  thirdIndex k;
  Array<float,2> tmp(invXTX_spvar.extent(fifthDim),C1.extent(firstDim));
  Array<float,2> middle(C1.extent(firstDim),C1.extent(firstDim));
  Array<float,2> invXTX(invXTX_spvar.extent(fifthDim),invXTX_spvar.extent(sixthDim));
  Contrast_image=0.;
  F_contrast_image=1.;

  // Using [(CB^-CB)'*(CVC')-1*(CB^-CB)]/s2
  // Do this multiplication over image, since C doesn't spatially vary, and B already incorporated spatially varying X
   for(b=0; b<Bimage.extent(fourthDim); b++) {
      for(c=0; c<C1.extent(firstDim); c++) {
	F_contrast_image(Range::all(),Range::all(),Range::all(),b,c)/=SSEimage(Range::all(),Range::all(),Range::all(),b,b);
	for(a=0; a<C1.extent(secondDim); a++) {
	  Contrast_image(Range::all(),Range::all(),Range::all(),b,c)+=C1(c,a)*Bimage(Range::all(),Range::all(),Range::all(),b,a);

	}
      }
   }
  F_contrast_image*=(Contrast_image*Contrast_image*(float)*df);
  
  // now compute "middle", (CVC')-1, since V=(X'X)-1, (CVC')-1 will change at every voxel
  // create contrast estimates at each voxel
  for(g=0; g<Bimage.extent(fourthDim); g++) {
    for(f=0; f<Bimage.extent(thirdDim); f++) {
      for(e=0; e<Bimage.extent(secondDim); e++) {
	for(d=0; d<Bimage.extent(firstDim); d++) {
	  invXTX=invXTX_spvar(d,e,f,g,Range::all(),Range::all());
	  tmp=sum(invXTX(i,k)*C1(j,k),k);
	  middle=sum(C1(i,k)*tmp(k,j),k);
	  for(a=0; a<C1.extent(firstDim); a++) {
	    F_contrast_image(d,e,f,g,a)/=middle(a,a);
	  }
	}
      }
    }
  }
  return(0);
}

int calc_contrast_images_spvar_multi(Array<float,2> C1, Array<float,6> invXTX_spvar, Array<float,5> Bimage,Array<float,5> SSEimage,Array<float,5> Contrast_image,Array<float,5> F_contrast_image,float *df) {
  int a,b,c;
  int d,e,f,g;
  firstIndex i;
  secondIndex j;
  thirdIndex k;
  Array<float,2> tmp(invXTX_spvar.extent(fifthDim),C1.extent(firstDim));
  Array<float,2> middle(C1.extent(firstDim),C1.extent(firstDim));
  Array<float,2> invXTX(invXTX_spvar.extent(fifthDim),invXTX_spvar.extent(sixthDim));
  Contrast_image=0.;
  F_contrast_image=1.;

  // Using [(CB^-CB)'*(CVC')-1*(CB^-CB)]/s2
  // Do this multiplication over image, since C doesn't spatially vary, and B already incorporated spatially varying X
   for(b=0; b<Bimage.extent(fourthDim); b++) {
      for(c=0; c<C1.extent(firstDim); c++) {
	F_contrast_image(Range::all(),Range::all(),Range::all(),b,c)/=SSEimage(Range::all(),Range::all(),Range::all(),b,b);
	for(a=0; a<C1.extent(secondDim); a++) {
	  Contrast_image(Range::all(),Range::all(),Range::all(),b,c)+=C1(c,a)*Bimage(Range::all(),Range::all(),Range::all(),b,a);

	}
      }
   }
  F_contrast_image*=(Contrast_image*Contrast_image*(float)*df);
  
  // now compute "middle", (CVC')-1, since V=(X'X)-1, (CVC')-1 will change at every voxel
  // create contrast estimates at each voxel
  for(g=0; g<Bimage.extent(fourthDim); g++) {
    for(f=0; f<Bimage.extent(thirdDim); f++) {
      for(e=0; e<Bimage.extent(secondDim); e++) {
	for(d=0; d<Bimage.extent(firstDim); d++) {
	  invXTX=invXTX_spvar(d,e,f,0,Range::all(),Range::all());
	  tmp=sum(invXTX(i,k)*C1(j,k),k);
	  middle=sum(C1(i,k)*tmp(k,j),k);
	  for(a=0; a<C1.extent(firstDim); a++) {
	    F_contrast_image(d,e,f,g,a)/=middle(a,a);
	  }
	}
      }
    }
  }
  return(0);
}


void indexx(int nn, Array<float,1> arrin, Array<int,1> indx) {
  int ll, jj, ir, indxt, ii;
  float q;
  firstIndex  i;

  indx=i;
  if(nn==1) return;
  ll=(nn>>1)+1;
  ir=nn;
  for(;;) {
    if(ll>1) {
      q=arrin( (indxt=indx((--ll)-1 ) ) );
    }
    else {
      q=arrin(  (indxt=indx(ir-1) ) );
      indx(ir-1)=indx(0);
      if(--ir ==1) {
	indx(0)=indxt;
	return;
      }
    }
    ii=ll;
    jj= (ll << 1) ;
    while (jj<=ir) {
      if(jj<ir && (arrin(indx(jj-1)) < arrin(indx(jj)))) jj++;
      if(q < arrin(indx(jj-1))) {
	indx(ii-1)=indx(jj-1);
	jj += (ii=jj);
      }
      else jj=ir+1;
    }
    indx(ii-1)=indxt;
  }
}


int permutations(ofstream *toFile,Array<float,5> images,Array<float,2> X,Array<float,2> X2,Array<float,2> C1, Array<float,5> Bimage,Array<float,5> B2image,Array<float,3> Stat_image,float *df1,float *df2,Array<float,5> Stat_param_image,float *tdf,Array<float,5> Contrast_image,Array<float,5> F_contrast_image,float *cdf1,float *cdf2,Array<float,4> Stat_R2_image,Uniform<float> unif, int num_perm, Array<float,1> Stat_Fmax,Array<float,1> Stat_Fmin, Array<float,3> Stat_param_Tmax, Array<float,3> Stat_param_Tmin,Array<float,3> Stat_contrast_Fmax,Array<float,3> Stat_contrast_Fmin) {
  int a,b,c, fin_OK;

  // maybe change so that instead of passing perm arrays, they are made in here?
  // should just need to pass back the thresholds, right?
  // 5/30/08
  Stat_Fmax=0.; Stat_Fmin=0.; Stat_param_Tmax=0.; Stat_param_Tmin=0.; Stat_contrast_Fmax=0.; Stat_contrast_Fmin=0.;
  for(a=0; a<num_perm; a++) {
    if( (fin_OK=solve_stat(toFile,images,X,X2,C1,Bimage,B2image,Stat_image,cdf1,cdf2,Stat_param_image,tdf,Contrast_image,F_contrast_image,cdf1,cdf2,Stat_R2_image,unif,1))!=0) {
      *(toFile) << "ERROR: could not solve model" << endl;
      cout << "ERROR: could not solve model, exiting" << endl;
      exit(1);
    }
    // fill max and min matrices
    // AH!! don't need to do for F statistics, always positive
    Stat_Fmax(a)=max(Stat_image);
    for(b=0; b<Stat_param_Tmax.extent(firstDim); b++) {
      for(c=0; c<Stat_param_Tmax.extent(secondDim); c++) {
	Stat_param_Tmax(b,c,a)=max(Stat_param_image(Range::all(),Range::all(),Range::all(),b,c));
	Stat_param_Tmin(b,c,a)=min(Stat_param_image(Range::all(),Range::all(),Range::all(),b,c));
      }
      for(c=0; c<Stat_contrast_Fmax.extent(secondDim); c++) {
	Stat_contrast_Fmax(b,c,a)=max(F_contrast_image(Range::all(),Range::all(),Range::all(),b,c));
      }
    }
    cout << "permutation " << a << endl;
  }
  // now to sort?
  mysort(Stat_Fmax, num_perm);
  for(b=0; b<Stat_param_Tmax.extent(firstDim); b++) {
    for(c=0; c<Stat_param_Tmax.extent(secondDim); c++) {
      mysort(Stat_param_Tmax(b,c,Range::all()),num_perm);
      mysort(Stat_param_Tmin(b,c,Range::all()),num_perm);
    }
    for(c=0; c<Stat_contrast_Fmax.extent(secondDim); c++) {
      mysort(Stat_contrast_Fmax(b,c,Range::all()),num_perm);
    }
  }
  *(toFile) << "model F threshold: " << Stat_Fmax((int)(0.95*num_perm)) << endl;
  for(b=0; b<Stat_param_Tmax.extent(firstDim); b++) {
    *(toFile) << "for dependent variable " << b << endl;
    for(c=0; c<Stat_param_Tmax.extent(secondDim); c++) {
      *(toFile) << "p=0.05 Positive threshold for independent variable " << c << ": " << Stat_param_Tmax(b,c,(int)(0.95*num_perm)) << endl;
      *(toFile) << "p=0.05 negative threshold for independent variable " << c << ": " << Stat_param_Tmin(b,c,(int)(0.05*num_perm)) << endl;
    }
    for(c=0; c<Stat_contrast_Fmax.extent(secondDim); c++) {
      *(toFile) << "for contrast " << c << ": " << Stat_contrast_Fmax(b,c, (int)(0.95*num_perm) ) << endl;
    }
  }

  cout << "run " << num_perm << " permutations" << endl;
  return(0);
}

int permutations_spvar(ofstream *toFile,Array<float,5> images,Array<float,6> ind_images,int num_spvar_indep_var,Array<float,2> X,Array<float,2> X2,Array<float,2> C1, Array<float,5> Bimage,Array<float,5> B2image,Array<float,3> Stat_image,float *df1,float *df2,Array<float,5> Stat_param_image,float *tdf,Array<float,5> Contrast_image,Array<float,5> F_contrast_image,float *cdf1,float *cdf2,Array<float,4> Stat_R2_image,Uniform<float> unif, int num_perm, Array<float,1> Stat_Fmax,Array<float,1> Stat_Fmin, Array<float,3> Stat_param_Tmax, Array<float,3> Stat_param_Tmin,Array<float,3> Stat_contrast_Fmax,Array<float,3> Stat_contrast_Fmin) {
  int a,b,c, fin_OK;

  // maybe change so that instead of passing perm arrays, they are made in here?
  // should just need to pass back the thresholds, right?
  // 5/30/08
  Stat_Fmax=0.; Stat_Fmin=0.; Stat_param_Tmax=0.; Stat_param_Tmin=0.; Stat_contrast_Fmax=0.; Stat_contrast_Fmin=0.;
  for(a=0; a<num_perm; a++) {
    if( (fin_OK=solve_stat_spvar(toFile,images,ind_images,num_spvar_indep_var,X,X2,C1,Bimage,B2image,Stat_image,cdf1,cdf2,Stat_param_image,tdf,Contrast_image,F_contrast_image,cdf1,cdf2,Stat_R2_image,unif,1))!=0) {
      *(toFile) << "ERROR: could not solve model" << endl;
      cout << "ERROR: could not solve model, exiting" << endl;
      exit(1);
    }
    // fill max and min matrices
    // AH!! don't need to do for F statistics, always positive
    Stat_Fmax(a)=max(Stat_image);
    for(b=0; b<Stat_param_Tmax.extent(firstDim); b++) {
      for(c=0; c<Stat_param_Tmax.extent(secondDim); c++) {
	Stat_param_Tmax(b,c,a)=max(Stat_param_image(Range::all(),Range::all(),Range::all(),b,c));
	Stat_param_Tmin(b,c,a)=min(Stat_param_image(Range::all(),Range::all(),Range::all(),b,c));
      }
      for(c=0; c<Stat_contrast_Fmax.extent(secondDim); c++) {
	Stat_contrast_Fmax(b,c,a)=max(F_contrast_image(Range::all(),Range::all(),Range::all(),b,c));
      }
    }
    cout << "permutation " << a << endl;
  }
  // now to sort?
  mysort(Stat_Fmax, num_perm);
  for(b=0; b<Stat_param_Tmax.extent(firstDim); b++) {
    for(c=0; c<Stat_param_Tmax.extent(secondDim); c++) {
      mysort(Stat_param_Tmax(b,c,Range::all()),num_perm);
      mysort(Stat_param_Tmin(b,c,Range::all()),num_perm);
    }
    for(c=0; c<Stat_contrast_Fmax.extent(secondDim); c++) {
      mysort(Stat_contrast_Fmax(b,c,Range::all()),num_perm);
    }
  }
  *(toFile) << "model F threshold: " << Stat_Fmax((int)(0.95*num_perm)) << endl;
  for(b=0; b<Stat_param_Tmax.extent(firstDim); b++) {
    *(toFile) << "for dependent variable " << b << endl;
    for(c=0; c<Stat_param_Tmax.extent(secondDim); c++) {
      *(toFile) << "p=0.05 Positive threshold for independent variable " << c << ": " << Stat_param_Tmax(b,c,(int)(0.95*num_perm)) << endl;
      *(toFile) << "p=0.05 negative threshold for independent variable " << c << ": " << Stat_param_Tmin(b,c,(int)(0.05*num_perm)) << endl;
    }
    for(c=0; c<Stat_contrast_Fmax.extent(secondDim); c++) {
      *(toFile) << "for contrast " << c << ": " << Stat_contrast_Fmax(b,c, (int)(0.95*num_perm) ) << endl;
    }
  }

  cout << "run " << num_perm << " permutations" << endl;
  return(0);
}


void mysort(Array<float,1> data, int N) {
  int ii,jj;
  float v, t;

  if(N<=1) return;

  // Partition elements
  v=data(0);
  ii=0;
  jj=N;
  for(;;) {
    while( data(++ii) < v && ii < N) {}
    while( data(--jj) > v) {}
    if(ii >= jj) break;
    t=data(ii); data(ii)=data(jj); data(jj)=t;
  }
  t=data(ii-1); data(ii-1)=data(0); data(0)=t;
  mysort(data,ii-1);
  mysort(data(Range(ii,N)),N-ii);
}

int permutations_multi(ofstream *toFile,Array<float,5> images,Array<float,2> X,Array<float,2> X2,Array<float,2> C1, Array<float,5> Bimage,Array<float,5> B2image,Array<float,3> Stat_image,Array<float,4> FStat_Manova,float *df1,float *df2,float *df3, float *df4,Array<float,5> Stat_param_image,float *tdf,Array<float,5> Contrast_image,Array<float,5> F_contrast_image,Array<float,4> F_contrast_image_multi,float *cdf1,float *cdf2,Array<float,4> Stat_R2_image,Uniform<float> unif, int num_perm, Array<float,1> Stat_Fmax,Array<float,1> Stat_Fmin, Array<float,3> Stat_param_Tmax, Array<float,3> Stat_param_Tmin,Array<float,3> Stat_contrast_Fmax,Array<float,3> Stat_contrast_Fmin,Array<float,2> Stat_FMaxManova,Array<float,2> Stat_FMaxContrastManova) {
  int a,b,c, fin_OK;

  // maybe change so that instead of passing perm arrays, they are made in here?
  // should just need to pass back the thresholds, right?
  // 5/30/08
  Stat_Fmax=0.; Stat_Fmin=0.; Stat_param_Tmax=0.; Stat_param_Tmin=0.; Stat_contrast_Fmax=0.; Stat_contrast_Fmin=0.;
  Stat_FMaxManova=0.; Stat_FMaxContrastManova=0.;
  for(a=0; a<num_perm; a++) {
    if( (fin_OK=solve_stat_multi(toFile,images,X,X2,C1,Bimage,B2image,Stat_image,FStat_Manova,df1,df2,df3,df4,Stat_param_image,tdf,Contrast_image,F_contrast_image,F_contrast_image_multi,cdf1,cdf2,Stat_R2_image,unif,1))!=0) {
      *(toFile) << "ERROR: could not solve model" << endl;
      cout << "ERROR: could not solve model, exiting" << endl;
      exit(1);
    }
    // fill max and min matrices
    // AH!! don't need to do for F statistics, always positive
    Stat_Fmax(a)=max(Stat_image);
    for(b=0; b<FStat_Manova.extent(fourthDim); b++) {
      Stat_FMaxManova(b,a)=max(FStat_Manova(Range::all(),Range::all(),Range::all(),b));
    }
    for(b=0; b<F_contrast_image_multi.extent(fourthDim); b++) {
      Stat_FMaxContrastManova(b,a)=max(F_contrast_image_multi(Range::all(),Range::all(),Range::all(),b));
    }
    for(b=0; b<Stat_param_Tmax.extent(firstDim); b++) {
      for(c=0; c<Stat_param_Tmax.extent(secondDim); c++) {
	Stat_param_Tmax(b,c,a)=max(Stat_param_image(Range::all(),Range::all(),Range::all(),b,c));
	Stat_param_Tmin(b,c,a)=min(Stat_param_image(Range::all(),Range::all(),Range::all(),b,c));
      }
      for(c=0; c<Stat_contrast_Fmax.extent(secondDim); c++) {
	Stat_contrast_Fmax(b,c,a)=max(F_contrast_image(Range::all(),Range::all(),Range::all(),b,c));
      }
    }
    cout << "permutation " << a << endl;
  }
  // now to sort?
  mysort(Stat_Fmax, num_perm);
  *(toFile) << "overall model F-threshold: " << Stat_Fmax((int)(0.95*num_perm)) << endl;
  for(b=0; b<FStat_Manova.extent(fourthDim); b++) {
    mysort(Stat_FMaxManova(b,Range::all()),num_perm);
    *(toFile) << "overall model F-threshold for IV " << b << ": " << Stat_FMaxManova(b,(int)(0.95*num_perm)) << endl;
  }
  for(b=0; b<F_contrast_image_multi.extent(fourthDim); b++) {
    mysort(Stat_FMaxContrastManova(b,Range::all()),num_perm);
    *(toFile) << "overall model F-threshold for contrast " << b << ": " << Stat_FMaxContrastManova(b,(int)(0.95*num_perm)) << endl;
  }
  for(b=0; b<Stat_param_Tmax.extent(firstDim); b++) {
    for(c=0; c<Stat_param_Tmax.extent(secondDim); c++) {
      mysort(Stat_param_Tmax(b,c,Range::all()),num_perm);
      mysort(Stat_param_Tmin(b,c,Range::all()),num_perm);
    }
    for(c=0; c<Stat_contrast_Fmax.extent(secondDim); c++) {
      mysort(Stat_contrast_Fmax(b,c,Range::all()),num_perm);
    }
  }

  for(b=0; b<Stat_param_Tmax.extent(firstDim); b++) {
    *(toFile) << "for dependent variable " << b << endl;
    for(c=0; c<Stat_param_Tmax.extent(secondDim); c++) {
      *(toFile) << "p=0.05 Positive T-threshold for independent variable " << c << ": " << Stat_param_Tmax(b,c,(int)(0.95*num_perm)) << endl;
      *(toFile) << "p=0.05 negative T-threshold for independent variable " << c << ": " << Stat_param_Tmin(b,c,(int)(0.05*num_perm)) << endl;
    }
    for(c=0; c<Stat_contrast_Fmax.extent(secondDim); c++) {
      *(toFile) << "p=0.05 F-threshold for contrast " << c << ": " << Stat_contrast_Fmax(b,c, (int)(0.95*num_perm) ) << endl;
    }
  }

  cout << "run " << num_perm << " permutations" << endl;
  return(0);
}

int solve_stat_static_spvar(ofstream *toFile,Array<float,4> imageMask,Array<float,2> Y,Array<float,6> ind_images,int num_spvar_indep_var, Array<float,2> X,Array<float,2> X2,Array<float,2> C1, Array<float,5> Bimage,Array<float,5> B2image,Array<float,3> Stat_image,float *df1, float *df2, Array<float,5> Stat_param_image, float *tdf, Array<float,5> Contrast_image,Array<float,5> F_contrast_image,float *cdf1, float *cdf2, Array<float,4> Stat_R2_image,Uniform<float> unif, int perm) {
  int fin_OK;
  int a;
  firstIndex i;
  secondIndex j;
  thirdIndex k;
  Array<float,1> ranVec(Y.extent(secondDim));
  Array<int,1> ranIndex(Y.extent(secondDim));
  if(perm!=0) {
    for(a=0; a<ranVec.rows(); a++) {
      ranVec(a)=unif.random();
    }
    indexx(ranVec.rows(),ranVec,ranIndex);
  }
  else ranIndex=i;

  //create XTXextra (extra rows for cholesky decomposition)
  Array<float,6> XTXextra(ind_images.extent(firstDim),ind_images.extent(secondDim),ind_images.extent(thirdDim),ind_images.extent(fourthDim),X.extent(secondDim),num_spvar_indep_var);

  // now solve full problem using Cholesky decomposition
  if( (fin_OK=cholesky_solve_static_spvar(Y,ind_images,num_spvar_indep_var,X,XTXextra,Bimage,ranIndex, perm))!=0) {
    *(toFile) << "ERROR: could not solve full least squares problem" << endl;
    cout << "ERROR: could not solve full least squares problem, exiting" << endl;
    exit(1);
  }
  // now solve reduced problem using Cholesky decomposition
  if( (fin_OK=cholesky_solve_static(Y,X2,B2image,ranIndex, perm))!=0) {
    *(toFile) << "ERROR: could not solve reduced least squares problem" << endl;
    cout << "ERROR: could not solve reduced least squares problem, exiting" << endl;
    exit(1);
  }

  // now calculate SSE and SSH
  Array<float,5> SSHimage(Bimage.extent(firstDim), Bimage.extent(secondDim),Bimage.extent(thirdDim),Bimage.extent(fourthDim),Bimage.extent(fourthDim));
  Array<float,5> SSEimage(Bimage.extent(firstDim), Bimage.extent(secondDim),Bimage.extent(thirdDim),Bimage.extent(fourthDim),Bimage.extent(fourthDim));
  
  if( (fin_OK=SSResids_spvar_static(Y,ind_images,num_spvar_indep_var,X,Bimage,SSEimage,ranIndex,perm))!=0) {
    *(toFile) << "ERROR: could not compute SSH" << endl;
    cout << "ERROR: could not compute SSH, exiting" << endl;
    exit(1);
  }
  if( (fin_OK=SSResids_static(Y,X2,B2image,SSHimage,ranIndex,perm))!=0) {
    *(toFile) << "ERROR: could not compute SSH" << endl;
    cout << "ERROR: could not computer SSH, exiting" << endl;
    exit(1);
  }
  // now calculate F statistics, R2 image, T2 statistics for each variable
  if( (fin_OK=calc_F_image(SSHimage,SSEimage,Stat_image, Bimage.extent(fourthDim),Y.extent(secondDim)-X.extent(secondDim),X.extent(secondDim)-X2.extent(secondDim),df1,df2))!=0) {
    *(toFile) << "ERROR: could not compute model F image" << endl;
    cout << "ERROR: could not computer model F image, exiting" << endl;
    exit(1);
  }

  Array<float,6> invXTX_spvar(Bimage.extent(firstDim),Bimage.extent(secondDim),Bimage.extent(thirdDim),Bimage.extent(fourthDim),X.extent(secondDim),X.extent(secondDim));
  Array<float,2> XTX(X.extent(secondDim),X.extent(secondDim));
 XTX=sum( X(k,i)*X(k,j),k);

  // fill invXTX_spvar with inverse of matrix at all voxels
  if( (fin_OK=invSPD_spvar(XTX,XTXextra,invXTX_spvar) ) !=0 ) {
    cout << "ERROR: could not invert SPD matrix at every voxel, exiting" << endl;
    exit(1);
  }

  *tdf=Y.extent(secondDim)-(X.extent(secondDim)-X2.extent(secondDim))-1;
  
  if( (fin_OK=calc_param_image_spvar(Bimage,SSEimage,Stat_param_image,invXTX_spvar,tdf ))!=0) {
    *(toFile) << "ERROR: could not compute t-statistic images for each independent variable" << endl;
    cout << "ERROR: could not computer t-statistic images for each independent variable, exiting" << endl;
    exit(1);
  }
  //  for(a=0; a<Stat_param_image.extent(fifthDim); a++) *(toFile) << "Stat_param_image " << a << "\t" << min(Stat_param_image(Range::all(), Range::all(), Range::all(), Range::all(), a)) << "\t" << max(Stat_param_image(Range::all(), Range::all(), Range::all(), Range::all(),a)) << endl;
  if(C1.extent(firstDim)!=0) {
    *cdf1=C1.extent(firstDim);
    *cdf2=Y.extent(secondDim)-X.extent(secondDim);
    if( (fin_OK=calc_contrast_images_spvar(C1,invXTX_spvar,Bimage,SSEimage,Contrast_image,F_contrast_image,cdf2)!=0)) {
      *(toFile) << "ERROR: could not compute contrast images" << endl;
      cout << "ERROR: could not computer contrats images, exiting" << endl;
      exit(1);
    }
  }
  if( (fin_OK=calc_R2_image(SSEimage,SSHimage,Stat_R2_image))!=0) {
    *(toFile) << "ERROR: could not calculate R2 images" << endl;
    cout << "ERROR: could not calculate R2 images, exiting" << endl;
    exit(1);
    }
  //  *(toFile) << "R2_image " << min(Stat_R2_image(Range::all(),Range::all(),Range::all(),Range::all())) << "\t" << max(Stat_R2_image(Range::all(),Range::all(),Range::all(),Range::all())) << endl;
  return(0);
}

int permutations_spvar_static(ofstream *toFile,Array<float,4> imageMask,Array<float,2> Y,Array<float,6> ind_images,int num_spvar_indep_var,Array<float,2> X,Array<float,2> X2,Array<float,2> C1, Array<float,5> Bimage,Array<float,5> B2image,Array<float,3> Stat_image,float *df1,float *df2,Array<float,5> Stat_param_image,float *tdf,Array<float,5> Contrast_image,Array<float,5> F_contrast_image,float *cdf1,float *cdf2,Array<float,4> Stat_R2_image,Uniform<float> unif, int num_perm, Array<float,1> Stat_Fmax,Array<float,1> Stat_Fmin, Array<float,3> Stat_param_Tmax, Array<float,3> Stat_param_Tmin,Array<float,3> Stat_contrast_Fmax,Array<float,3> Stat_contrast_Fmin) {
  int a,b,c, fin_OK;

  // maybe change so that instead of passing perm arrays, they are made in here?
  // should just need to pass back the thresholds, right?
  // 5/30/08
  Stat_Fmax=0.; Stat_Fmin=0.; Stat_param_Tmax=0.; Stat_param_Tmin=0.; Stat_contrast_Fmax=0.; Stat_contrast_Fmin=0.;
  for(a=0; a<num_perm; a++) {
    if( (fin_OK=solve_stat_static_spvar(toFile,imageMask,Y,ind_images,num_spvar_indep_var,X,X2,C1,Bimage,B2image,Stat_image,cdf1,cdf2,Stat_param_image,tdf,Contrast_image,F_contrast_image,cdf1,cdf2,Stat_R2_image,unif,1))!=0) {
      *(toFile) << "ERROR: could not solve model" << endl;
      cout << "ERROR: could not solve model, exiting" << endl;
      exit(1);
    }
    // fill max and min matrices
    // AH!! don't need to do for F statistics, always positive
    Stat_Fmax(a)=max(Stat_image);
    for(b=0; b<Stat_param_Tmax.extent(firstDim); b++) {
      for(c=0; c<Stat_param_Tmax.extent(secondDim); c++) {
	Stat_param_Tmax(b,c,a)=max(Stat_param_image(Range::all(),Range::all(),Range::all(),b,c));
	Stat_param_Tmin(b,c,a)=min(Stat_param_image(Range::all(),Range::all(),Range::all(),b,c));
      }
      for(c=0; c<Stat_contrast_Fmax.extent(secondDim); c++) {
	Stat_contrast_Fmax(b,c,a)=max(F_contrast_image(Range::all(),Range::all(),Range::all(),b,c));
      }
    }
    cout << "permutation " << a << endl;
  }
  // now to sort?
  mysort(Stat_Fmax, num_perm);
  for(b=0; b<Stat_param_Tmax.extent(firstDim); b++) {
    for(c=0; c<Stat_param_Tmax.extent(secondDim); c++) {
      mysort(Stat_param_Tmax(b,c,Range::all()),num_perm);
      mysort(Stat_param_Tmin(b,c,Range::all()),num_perm);
    }
    for(c=0; c<Stat_contrast_Fmax.extent(secondDim); c++) {
      mysort(Stat_contrast_Fmax(b,c,Range::all()),num_perm);
    }
  }
  *(toFile) << "model F threshold: " << Stat_Fmax((int)(0.95*num_perm)) << endl;
  for(b=0; b<Stat_param_Tmax.extent(firstDim); b++) {
    *(toFile) << "for dependent variable " << b << endl;
    for(c=0; c<Stat_param_Tmax.extent(secondDim); c++) {
      *(toFile) << "p=0.05 Positive threshold for independent variable " << c << ": " << Stat_param_Tmax(b,c,(int)(0.95*num_perm)) << endl;
      *(toFile) << "p=0.05 negative threshold for independent variable " << c << ": " << Stat_param_Tmin(b,c,(int)(0.05*num_perm)) << endl;
    }
    for(c=0; c<Stat_contrast_Fmax.extent(secondDim); c++) {
      *(toFile) << "for contrast " << c << ": " << Stat_contrast_Fmax(b,c, (int)(0.95*num_perm) ) << endl;
    }
  }

  cout << "run " << num_perm << " permutations" << endl;
  return(0);
}

int solve_stat_multi_staticdv_spvar(ofstream *toFile,Array<float,2> Y,Array<float,6> ind_images,int num_spvar_indep_var,Array<float,2> X,Array<float,2> X2,Array<float,2> C1, Array<float,5> Bimage,Array<float,5> B2image,Array<float,3> Stat_image,Array<float,4> FStat_Manova,float *df1, float *df2, float *df3, float *df4, Array<float,5> Stat_param_image, float *tdf, Array<float,5> Contrast_image,Array<float,5> F_contrast_image,Array<float,4> F_contrast_image_multi,float *cdf1, float *cdf2, Array<float,4> Stat_R2_image,Uniform<float> unif, int perm) {
  int fin_OK;
  int a;
  firstIndex i;
  secondIndex j;
  thirdIndex k;

  Array<float,1> ranVec(Y.extent(secondDim));
  Array<int,1> ranIndex(Y.extent(secondDim));
  if(perm!=0) {
    for(a=0; a<ranVec.rows(); a++) {
      ranVec(a)=unif.random();
    }
    indexx(ranVec.rows(),ranVec,ranIndex);
  }
  else ranIndex=i;

  //create XTXextra (extra rows for cholesky decomposition)
  Array<float,6> XTXextra(ind_images.extent(firstDim),ind_images.extent(secondDim),ind_images.extent(thirdDim),ind_images.extent(fourthDim),X.extent(secondDim),num_spvar_indep_var);

  //  cout << "before cholesky_solve" << endl;
  // now solve full problem using Cholesky decomposition
  if( (fin_OK=cholesky_solve_mult_static_spvar(Y,ind_images,num_spvar_indep_var,X,XTXextra,Bimage,ranIndex, perm))!=0) {
    *(toFile) << "ERROR: could not solve full least squares problem" << endl;
    cout << "ERROR: could not solve full least squares problem, exiting" << endl;
    exit(1);
  }
  //  cout << "after cholesky_solve for full X" << endl;
  //  cout << Bimage(0,0,0,Range::all(),Range::all()) << endl;

  // now solve reduced problem using Cholesky decomposition
  if( (fin_OK=cholesky_solve_mult_static(Y,X2,B2image,ranIndex, perm))!=0) {
    *(toFile) << "ERROR: could not solve reduced least squares problem" << endl;
    cout << "ERROR: could not solve reduced least squares problem, exiting" << endl;
    exit(1);
  }

  // if desired, correct for imageMask
  //  for(a=0; a<num_effects+num_confounds; a++) Bimage(Range::all(), Range::all(), Range::all(), Range::all(),a)*=imageMask;
  //  for(a=0; a<num_confounds; a++) B2image(Range::all(), Range::all(), Range::all(), Range::all(),a)*=imageMask;

  // write min and max values for each beta to file
  //  for(a=0; a<Bimage.extent(fifthDim); a++) *(toFile) << "Bimage " << a << "\t" << min(Bimage(Range::all(), Range::all(), Range::all(), Range::all(), a)) << "\t" << max(Bimage(Range::all(), Range::all(), Range::all(), Range::all(),a)) << endl;
  //  for(a=0; a<B2image.extent(fifthDim); a++) *(toFile) << "B2image " << a << "\t" << min(B2image(Range::all(), Range::all(), Range::all(), Range::all(), a)) << "\t" << max(B2image(Range::all(), Range::all(), Range::all(), Range::all(),a)) <<endl;
  // now calculate SSE and SSH
  Array<float,5> SSHimage(Bimage.extent(firstDim), Bimage.extent(secondDim),Bimage.extent(thirdDim),Bimage.extent(fourthDim),Bimage.extent(fourthDim));
  Array<float,5> SSEimage(Bimage.extent(firstDim), Bimage.extent(secondDim),Bimage.extent(thirdDim),Bimage.extent(fourthDim),Bimage.extent(fourthDim));
  Array<float,6> SSH2image(Bimage.extent(firstDim), Bimage.extent(secondDim), Bimage.extent(thirdDim), X.extent(secondDim)-1,Bimage.extent(fourthDim),Bimage.extent(fourthDim));

  if( (fin_OK=SSResids_spvar_static(Y,ind_images,num_spvar_indep_var,X,Bimage,SSEimage,ranIndex,perm))!=0) {
    *(toFile) << "ERROR: could not compute SSH" << endl;
    cout << "ERROR: could not computer SSH, exiting" << endl;
    exit(1);
  }
  //  cout << "after SSResids for full X" << endl;
  if( (fin_OK=SSResids_static(Y,X2,B2image,SSHimage,ranIndex,perm))!=0) {
    *(toFile) << "ERROR: could not compute SSH" << endl;
    cout << "ERROR: could not computer SSH, exiting" << endl;
    exit(1);
  }
  if( (fin_OK=calc_R2_image(SSEimage,SSHimage,Stat_R2_image))!=0) {
    *(toFile) << "ERROR: could not calculate R2 images" << endl;
    cout << "ERROR: could not calculate R2 images, exiting" << endl;
    exit(1);
  }

  
  // now make SSH2image, which is (LB')(L(XTX)-1L')-1(LB), sort of
  Array<float,6> invXTX_spvar(ind_images.extent(firstDim),ind_images.extent(secondDim),ind_images.extent(thirdDim),ind_images.extent(fourthDim),X.extent(secondDim),X.extent(secondDim));
  Array<float,2> XTX(X.extent(secondDim),X.extent(secondDim));
 XTX=sum( X(k,i)*X(k,j),k);
 

  // fill invXTX_spvar with inverse of matrix at all voxels
  if( (fin_OK=invSPD_spvar(XTX,XTXextra,invXTX_spvar) ) !=0 ) {
    cout << "ERROR: could not invert SPD matrix at every voxel, exiting" << endl;
    exit(1);
  }

  if( (fin_OK=SSH2make_spvar(invXTX_spvar,Bimage,SSH2image)) !=0) {
    *(toFile) << "ERROR: could not compute SSH2" << endl;
    cout << "ERROR: could not computer SSH2, exiting" << endl;
    exit(1);
  }
  
  // now calculate F statistics, R2 image, T2 statistics for each variable
  Array<float,3> detSSE(SSEimage.extent(firstDim),SSEimage.extent(secondDim),SSEimage.extent(thirdDim));
  if( (fin_OK=calc_F_image_multi(SSHimage,SSEimage,detSSE,SSH2image,Stat_image, FStat_Manova,Y.extent(firstDim),Y.extent(secondDim)-X.extent(secondDim),X.extent(secondDim)-X2.extent(secondDim),df1,df2,df3,df4))!=0) {
    *(toFile) << "ERROR: could not compute model F image" << endl;
    cout << "ERROR: could not computer model F images, exiting" << endl;
    exit(1);
  }
  //  *(toFile) << "F_image " << min(Stat_image(Range::all(),Range::all(),Range::all())) << "\t" << max(Stat_image(Range::all(),Range::all(),Range::all())) << endl;
  
  *tdf=Y.extent(secondDim)-(X.extent(secondDim)-X2.extent(secondDim))-1;
  if( (fin_OK=calc_param_image_spvar_multi(Bimage,SSEimage,Stat_param_image,invXTX_spvar,tdf ))!=0) {
    *(toFile) << "ERROR: could not compute t-statistic images for each independent variable" << endl;
    cout << "ERROR: could not computer t-statistic images for each independent variable, exiting" << endl;
    exit(1);
  }
  
  //for(a=0; a<Stat_param_image.extent(fifthDim); a++) *(toFile) << "Stat_param_image " << a << "\t" << min(Stat_param_image(Range::all(), Range::all(), Range::all(), Range::all(), a)) << "\t" << max(Stat_param_image(Range::all(), Range::all(), Range::all(), Range::all(),a)) << endl;
  //cout << Stat_param_image(0,0,0,Range::all(),Range::all()) << endl;
  //cout << Stat_param_image(11,13,16,Range::all(),Range::all()) << endl;
  if(C1.extent(firstDim)!=0) {
    *cdf1=C1.extent(firstDim);
    *cdf2=Y.extent(secondDim)-X.extent(secondDim);
    // now make SSH2image, which is (CB')(C(XTX)-1C')-1(CB), sort of
    // resize SSH2image for number of contrasts (not number of independent variables
    SSH2image.resize(Bimage.extent(firstDim),Bimage.extent(secondDim),Bimage.extent(thirdDim),C1.extent(firstDim),Y.extent(firstDim),Y.extent(firstDim));
    if( (fin_OK=SSH2make_multi_spvar(C1,invXTX_spvar,Bimage,SSH2image)) !=0) {
      *(toFile) << "ERROR: could not compute SSH2" << endl;
      cout << "ERROR: could not computer SSH2, exiting" << endl;
      exit(1);
    } 
    
    if( (fin_OK=calc_contrast_images_spvar_multi(C1,invXTX_spvar,Bimage,SSEimage,Contrast_image,F_contrast_image,cdf2)!=0)) {
       *(toFile) << "ERROR: could not compute contrast images" << endl;
       cout << "ERROR: could not computer contrast images, exiting" << endl;
       exit(1);
    }
    
    if( (fin_OK=calc_contrast_images_multi(SSEimage,SSHimage,SSH2image,detSSE,F_contrast_image_multi,Y.extent(firstDim),df3,df4))!=0) {
      (*toFile) << "ERROR: could not compute contrasts on overall  model" << endl;
      cout << "ERROR: could not computer contrasts on overall model, exiting" << endl;
      exit(1);
    }

  }
  
  return(0);
}

int permutations_multi_staticdv_spvar(ofstream *toFile,Array<float,2> Y,Array<float,6> ind_images,int num_spvar_indep_var,Array<float,2> X,Array<float,2> X2,Array<float,2> C1, Array<float,5> Bimage,Array<float,5> B2image,Array<float,3> Stat_image,Array<float,4> FStat_Manova,float *df1,float *df2,float *df3, float *df4,Array<float,5> Stat_param_image,float *tdf,Array<float,5> Contrast_image,Array<float,5> F_contrast_image,Array<float,4> F_contrast_image_multi,float *cdf1,float *cdf2,Array<float,4> Stat_R2_image,Uniform<float> unif, int num_perm, Array<float,1> Stat_Fmax,Array<float,1> Stat_Fmin, Array<float,3> Stat_param_Tmax, Array<float,3> Stat_param_Tmin,Array<float,3> Stat_contrast_Fmax,Array<float,3> Stat_contrast_Fmin,Array<float,2> Stat_FMaxManova,Array<float,2> Stat_FMaxContrastManova) {
  int a,b,c, fin_OK;

  Stat_Fmax=0.; Stat_Fmin=0.; Stat_param_Tmax=0.; Stat_param_Tmin=0.; Stat_contrast_Fmax=0.; Stat_contrast_Fmin=0.;
  Stat_FMaxManova=0.; Stat_FMaxContrastManova=0.;
  for(a=0; a<num_perm; a++) {
    if( (fin_OK=solve_stat_multi_staticdv_spvar(toFile,Y,ind_images,num_spvar_indep_var,X,X2,C1,Bimage,B2image,Stat_image,FStat_Manova,df1,df2,df3,df4,Stat_param_image,tdf,Contrast_image,F_contrast_image,F_contrast_image_multi,cdf1,cdf2,Stat_R2_image,unif,1))!=0) {
      *(toFile) << "ERROR: could not solve model" << endl;
      cout << "ERROR: could not solve model, exiting" << endl;
      exit(1);
    }
    // fill max and min matrices
    // AH!! don't need to do for F statistics, always positive
    Stat_Fmax(a)=max(Stat_image);
    for(b=0; b<FStat_Manova.extent(fourthDim); b++) {
      Stat_FMaxManova(b,a)=max(FStat_Manova(Range::all(),Range::all(),Range::all(),b));
    }
    for(b=0; b<F_contrast_image_multi.extent(fourthDim); b++) {
      Stat_FMaxContrastManova(b,a)=max(F_contrast_image_multi(Range::all(),Range::all(),Range::all(),b));
    }
    for(b=0; b<Stat_param_Tmax.extent(firstDim); b++) {
      for(c=0; c<Stat_param_Tmax.extent(secondDim); c++) {
	Stat_param_Tmax(b,c,a)=max(Stat_param_image(Range::all(),Range::all(),Range::all(),b,c));
	Stat_param_Tmin(b,c,a)=min(Stat_param_image(Range::all(),Range::all(),Range::all(),b,c));
      }
      for(c=0; c<Stat_contrast_Fmax.extent(secondDim); c++) {
	Stat_contrast_Fmax(b,c,a)=max(F_contrast_image(Range::all(),Range::all(),Range::all(),b,c));
      }
    }
    cout << "permutation " << a << endl;
  }
  // now to sort?
  mysort(Stat_Fmax, num_perm);
  *(toFile) << "overall model F-threshold: " << Stat_Fmax((int)(0.95*num_perm)) << endl;
  for(b=0; b<FStat_Manova.extent(fourthDim); b++) {
    mysort(Stat_FMaxManova(b,Range::all()),num_perm);
    *(toFile) << "overall model F-threshold for IV " << b << ": " << Stat_FMaxManova(b,(int)(0.95*num_perm)) << endl;
  }
  for(b=0; b<F_contrast_image_multi.extent(fourthDim); b++) {
    mysort(Stat_FMaxContrastManova(b,Range::all()),num_perm);
    *(toFile) << "overall model F-threshold for contrast " << b << ": " << Stat_FMaxContrastManova(b,(int)(0.95*num_perm)) << endl;
  }
  for(b=0; b<Stat_param_Tmax.extent(firstDim); b++) {
    for(c=0; c<Stat_param_Tmax.extent(secondDim); c++) {
      mysort(Stat_param_Tmax(b,c,Range::all()),num_perm);
      mysort(Stat_param_Tmin(b,c,Range::all()),num_perm);
    }
    for(c=0; c<Stat_contrast_Fmax.extent(secondDim); c++) {
      mysort(Stat_contrast_Fmax(b,c,Range::all()),num_perm);
    }
  }

  for(b=0; b<Stat_param_Tmax.extent(firstDim); b++) {
    *(toFile) << "for dependent variable " << b << endl;
    for(c=0; c<Stat_param_Tmax.extent(secondDim); c++) {
      *(toFile) << "p=0.05 Positive T-threshold for independent variable " << c << ": " << Stat_param_Tmax(b,c,(int)(0.95*num_perm)) << endl;
      *(toFile) << "p=0.05 negative T-threshold for independent variable " << c << ": " << Stat_param_Tmin(b,c,(int)(0.05*num_perm)) << endl;
    }
    for(c=0; c<Stat_contrast_Fmax.extent(secondDim); c++) {
      *(toFile) << "p=0.05 F-threshold for contrast " << c << ": " << Stat_contrast_Fmax(b,c, (int)(0.95*num_perm) ) << endl;
    }
  }

  cout << "run " << num_perm << " permutations" << endl;
  return(0);
}
