/***************************************************************************
 *          solve_stat.h                                                   *
 *          solve images=XB                                                *
 *          5/19/08                                                        *
 ***************************************************************************/

#include <fstream>
#include <blitz/array.h>
#include <random/uniform.h>

using namespace std;
using namespace ranlib;
BZ_USING_NAMESPACE(blitz)


int solve_stat(ofstream *toFile,Array<float,5> images,Array<float,2> X,Array<float,2> X2,Array<float,2> C1, Array<float,5> Bimage,Array<float,5> B2image,Array<float,3> Stat_image,float *df1, float *df2, Array<float,5> Stat_param_image, float *tdf, Array<float,5> Contrast_image,Array<float,5> F_contrast_image,float *cdf1, float *cdf2, Array<float,4> Stat_R2_image,Uniform<float> unif, int perm);

int permutations(ofstream *toFile,Array<float,5> images,Array<float,2> X,Array<float,2> X2,Array<float,2> C1, Array<float,5> Bimage,Array<float,5> B2image,Array<float,3> Stat_image,float *df1,float *df2,Array<float,5> Stat_param_image,float *tdf, Array<float,5> Contrast_image,Array<float,5> F_contrast_image,float *cdf1,float *cdf2,Array<float,4> Stat_R2_image,Uniform<float> unif, int num_perm, Array<float,1> Stat_Fmax,Array<float,1> Stat_Fmin, Array<float,3> Stat_param_Tmax, Array<float,3> Stat_param_Tmin,Array<float,3> Stat_contrast_Fmax,Array<float,3> Stat_contrast_Fmin);

int solve_stat_spvar(ofstream *toFile,Array<float,5> images,Array<float,6> ind_images,int num_spvar_indep_var,Array<float,2> X,Array<float,2> X2,Array<float,2> C1, Array<float,5> Bimage,Array<float,5> B2image,Array<float,3> Stat_image,float *df1, float *df2, Array<float,5> Stat_param_image, float *tdf, Array<float,5> Contrast_image,Array<float,5> F_contrast_image,float *cdf1, float *cdf2, Array<float,4> Stat_R2_image,Uniform<float> unif, int perm);

int permutations_spvar(ofstream *toFile,Array<float,5> images,Array<float,6> ind_images,int num_spvar_indep_var,Array<float,2> X,Array<float,2> X2,Array<float,2> C1, Array<float,5> Bimage,Array<float,5> B2image,Array<float,3> Stat_image,float *df1,float *df2,Array<float,5> Stat_param_image,float *tdf,Array<float,5> Contrast_image,Array<float,5> F_contrast_image,float *cdf1,float *cdf2,Array<float,4> Stat_R2_image,Uniform<float> unif, int num_perm, Array<float,1> Stat_Fmax,Array<float,1> Stat_Fmin, Array<float,3> Stat_param_Tmax, Array<float,3> Stat_param_Tmin,Array<float,3> Stat_contrast_Fmax,Array<float,3> Stat_contrast_Fmin);

int solve_stat_multi(ofstream *toFile,Array<float,5> images,Array<float,2> X,Array<float,2> X2,Array<float,2> C1, Array<float,5> Bimage,Array<float,5> B2image,Array<float,3> Stat_image,Array<float,4> FStat_Manova,float *df1, float *df2, float *df3, float *df4,Array<float,5> Stat_param_image, float *tdf, Array<float,5> Contrast_image,Array<float,5> F_contrast_image,Array<float,4> F_contrast_image_multi,float *cdf1, float *cdf2, Array<float,4> Stat_R2_image,Uniform<float> unif, int perm);

int permutations_multi(ofstream *toFile,Array<float,5> images,Array<float,2> X,Array<float,2> X2,Array<float,2> C1, Array<float,5> Bimage,Array<float,5> B2image,Array<float,3> Stat_image,Array<float,4> FStat_Manova,float *df1,float *df2,float *df3, float *df4,Array<float,5> Stat_param_image,float *tdf,Array<float,5> Contrast_image,Array<float,5> F_contrast_image,Array<float,4> F_contrast_image_multi,float *cdf1,float *cdf2,Array<float,4> Stat_R2_image,Uniform<float> unif, int num_perm, Array<float,1> Stat_Fmax,Array<float,1> Stat_Fmin, Array<float,3> Stat_param_Tmax, Array<float,3> Stat_param_Tmin,Array<float,3> Stat_contrast_Fmax,Array<float,3> Stat_contrast_Fmin,Array<float,2> Stat_FMaxManova,Array<float,2> Stat_FMaxContrastManova);

int solve_stat_static_spvar(ofstream *toFile,Array<float,4> imageMask,Array<float,2> Y,Array<float,6> ind_images,int num_spvar_indep_var, Array<float,2> X,Array<float,2> X2,Array<float,2> C1, Array<float,5> Bimage,Array<float,5> B2image,Array<float,3> Stat_image,float *df1, float *df2, Array<float,5> Stat_param_image, float *tdf, Array<float,5> Contrast_image,Array<float,5> F_contrast_image,float *cdf1, float *cdf2, Array<float,4> Stat_R2_image,Uniform<float> unif, int perm);

int permutations_spvar_static(ofstream *toFile,Array<float,4> imageMask,Array<float,2> Y,Array<float,6> ind_images,int num_spvar_indep_var,Array<float,2> X,Array<float,2> X2,Array<float,2> C1, Array<float,5> Bimage,Array<float,5> B2image,Array<float,3> Stat_image,float *df1,float *df2,Array<float,5> Stat_param_image,float *tdf,Array<float,5> Contrast_image,Array<float,5> F_contrast_image,float *cdf1,float *cdf2,Array<float,4> Stat_R2_image,Uniform<float> unif, int num_perm, Array<float,1> Stat_Fmax,Array<float,1> Stat_Fmin, Array<float,3> Stat_param_Tmax, Array<float,3> Stat_param_Tmin,Array<float,3> Stat_contrast_Fmax,Array<float,3> Stat_contrast_Fmin);

int solve_stat_multi_staticdv_spvar(ofstream *toFile,Array<float,2> Y,Array<float,6> ind_images,int num_spvar_indep_var,Array<float,2> X,Array<float,2> X2,Array<float,2> C1, Array<float,5> Bimage,Array<float,5> B2image,Array<float,3> Stat_image,Array<float,4> FStat_Manova,float *df1, float *df2, float *df3, float *df4, Array<float,5> Stat_param_image, float *tdf, Array<float,5> Contrast_image,Array<float,5> F_contrast_image,Array<float,4> F_contrast_image_multi,float *cdf1, float *cdf2, Array<float,4> Stat_R2_image,Uniform<float> unif, int perm);

int permutations_multi_staticdv_spvar(ofstream *toFile,Array<float,2> Y,Array<float,6> ind_images,int num_spvar_indep_var,Array<float,2> X,Array<float,2> X2,Array<float,2> C1, Array<float,5> Bimage,Array<float,5> B2image,Array<float,3> Stat_image,Array<float,4> FStat_Manova,float *df1,float *df2,float *df3, float *df4,Array<float,5> Stat_param_image,float *tdf,Array<float,5> Contrast_image,Array<float,5> F_contrast_image,Array<float,4> F_contrast_image_multi,float *cdf1,float *cdf2,Array<float,4> Stat_R2_image,Uniform<float> unif, int num_perm, Array<float,1> Stat_Fmax,Array<float,1> Stat_Fmin, Array<float,3> Stat_param_Tmax, Array<float,3> Stat_param_Tmin,Array<float,3> Stat_contrast_Fmax,Array<float,3> Stat_contrast_Fmin,Array<float,2> Stat_FMaxManova,Array<float,2> Stat_FMaxContrastManova);
