/****************************************************************************
 *      threshold_mask.cpp                                                  *
 *      5/16/08                                                             *
 ****************************************************************************/

#include <blitz/array.h>
#include <fstream>
//#include <DataLoad.h>
//#include <DataCheck.h>
//#include <ByteSwap.h>
//#include <TypeAccess.h>
//#include <SimpleMayo.h>
//#include <DataSave.h>
//#include <BasicImage.h>
//#include <decomp.h>s

using namespace std;

BZ_USING_NAMESPACE(blitz)

int histogram(Array<float,4> imageMask,int nbin, Array<int,1> freq, Array<float,1> center);

int threshold_mask(Array<float,4> imageMask, char fname[200]) {
  int nbin, dbin, finOK,m_locmax;
  float thresh=0.;
  nbin=100;
  dbin=10;

  Array<int,1> freq(nbin);
  Array<float,1> center(nbin);
  Array<int,1> fnm1(nbin-dbin), fn(nbin-dbin), fnp1(nbin-dbin),locmax(nbin-dbin);
  if( (finOK=histogram(imageMask,nbin,freq,center))!=0) {
      cout << "problem with creating histogram for image masking threshold, exiting" << endl;
    exit(1);
  }
  else {
    fnm1=freq(Range(0,nbin-2*dbin-1));
    fn=freq(Range(dbin,nbin-dbin-1));
    fnp1=freq(Range(2*dbin,nbin-1));
    locmax=(abs(fn-fnm1)+abs(fn-fnp1))*(where(fn>fnp1,1,0))*(where(fn>fnm1,1,0));
    if( any(locmax)) {
      m_locmax=first(where(locmax==max(locmax),1,0))+dbin;
      thresh=center(first( where(freq==min(freq(Range(1,m_locmax))),1,0)));
      cout << "mask histogram threshold is: " << thresh << endl;
    }
    else {
      thresh=max(center)/4.;
      cout << "mask threshold is: " << thresh << endl;
    }
  }
  // now turn imageMask into array where values>thresh=1, and values<thresh=0
  imageMask=where(imageMask>=thresh,1,0);
 
  return(0);
}


// this histogram function works but is slow
// replace someday with faster version!!
// 5/16/08
int histogram(Array<float,4> imageMask,int nbin, Array<int,1> freq, Array<float,1> center) {
  float imageMin, imageMax,binWidth;
  int a;
  imageMin=min(imageMask);
  if(imageMin==-32768) imageMin=0.;
  imageMax=max(imageMask);

  binWidth=(imageMax-imageMin)/nbin;
  
  firstIndex i;
  center=(i+0.5)*binWidth;
  for(a=0; a<100; a++) {
    freq(a)=sum(where(imageMask>=a*binWidth,1,0)*where(imageMask<(a+1)*binWidth,1,0));
  }
  return(0);
}
