/*********************************************************************************************************
 *              write_images_nifti.h                                                                     *
 *              5/19/08                                                                                  *
 *********************************************************************************************************/
#include <fstream>
#include <blitz/array.h>
#include <nifti1.h>
#include <nifti1_io.h>
#include <znzlib.h>

#include "copy_nim.h"

using namespace std;

BZ_USING_NAMESPACE(blitz)

int writeMaskImage(ofstream *toFile, Array<float, 4> imageMask, nifti_image *nim /*float x_res, float y_res, float z_res*/, float zz_res, char fname[200]);
int writeBetaImage(ofstream *toFile, Array<float, 5> Bimage, nifti_image *nim /*float x_res, float y_res, float z_res, float zz_res*/,char templateName[200], char basename[200]);
int writeStatImage(ofstream *toFile, Array<float, 3> Stat_image, nifti_image *nim /*float x_res, float y_res, float z_res, float zz_res*/,char templateName[200],char basename[200],float *df1, float *df2);
int writeStatParamImage(ofstream *toFile, Array<float, 5> Stat_param_image, nifti_image *nim /*float x_res, float y_res, float z_res, float zz_res*/,char templateName[200],char basename[200],float *tdf);
int writeR2Image(ofstream *toFile, Array<float, 4> Stat_R2_image, nifti_image *nim /*float x_res, float y_res, float z_res, float zz_res*/,char templateName[200],char basename[200]);
int writeContrastImage(ofstream *toFile, Array<float, 5> Contrast_image, nifti_image *nim /*float x_res, float y_res, float z_res, float zz_res*/,char templateName[200],char basename[200]);
int writeContrastFImage(ofstream *toFile, Array<float, 5> F_contrast_image, nifti_image *nim /*float x_res, float y_res, float z_res, float zz_res*/,char templateName[200],char basename[200],float *cdf1,float *cdf2);
int writeFManova(ofstream *toFile, Array<float, 4> F_manova_image, nifti_image *nim /*float x_res, float y_res, float z_res, float zz_res*/,char templateName[200],char basename[200],const char label[20],float *df1,float *df2);
